--
-- kOOL - the church tool
-- www.churchtool.org
--
-- DB changes needed for update from R40 to R41
-- Important: Update DB before updating source
--


-- Add mailing alias field for small groups and groups
ALTER TABLE `ko_kleingruppen` ADD `mailing_alias` VARCHAR( 50 ) NOT NULL ;
ALTER TABLE `ko_kleingruppen` ADD INDEX ( `mailing_alias` ) ;
ALTER TABLE `ko_groups` ADD `mailing_alias` VARCHAR( 50 ) NOT NULL ;
ALTER TABLE `ko_groups` ADD INDEX ( `mailing_alias` ) ;


-- SMS sender IDs are now stored in DB (see update_R41.php)
INSERT INTO `ko_settings` (`key` , `value`) VALUES ('sms_sender_ids', 'kOOL');


-- New settings for new module mailing
INSERT INTO `ko_settings` ( `key` , `value`) VALUES ( 'mailing_mails_per_cycle', '30'), ( 'mailing_max_recipients', '0');



-- 2 tables for mailing module
CREATE TABLE `ko_mailing_mails` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `status` tinyint(4) NOT NULL,
  `user_id` mediumint(9) NOT NULL,
  `crdate` datetime NOT NULL,
  `code` varchar(32) NOT NULL,
  `recipient` varchar(100) NOT NULL,
  `from` varchar(255) NOT NULL,
  `subject` varchar(255) NOT NULL,
  `header` text NOT NULL,
  `body` longtext NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `status` (`status`,`code`)
) TYPE=MyISAM ;

CREATE TABLE `ko_mailing_recipients` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `mail_id` mediumint(8) unsigned NOT NULL,
  `name` varchar(200) NOT NULL,
  `email` varchar(200) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mail_id` (`mail_id`)
) TYPE=MyISAM ;
