<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2011 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require($BASE_PATH."inc/class.kOOL_listview.php");


//Erfassen
function ko_show_dp($dienst, $output=TRUE) {
	global $smarty, $DATETIME;
	global $access;

	if(!is_array($dienst) || sizeof($dienst) <= 0) return FALSE;

	ko_get_dp_events($events, $_SESSION["show_monat"], $_SESSION["show_jahr"]);
	$monat_status = ko_dp_get_monat_status( (str_to_2($_SESSION["show_monat"])."-".$_SESSION["show_jahr"]) );
	$counter = 0;
	$tpl_dp = array();
	$dateheader = "";
	$max_templates = (int)ko_get_setting("dp_max_templates");

	//Dienste, bei denen ein freies Textfeld erlaubt ist
	$freetext_dienste = explode(",", ko_get_setting("dp_freetext_dienste"));

	//Get all rota teams
	ko_get_dienste($all_teams);
	
	//Durch alle Events dieses Monates durchgehen
	foreach($events as $e_i => $e) {
		ko_get_eventgruppe_by_id($e["eventgruppen_id"], $tg);
		$tpl_dp[$counter]["titel"] = $tg["name"];
		$tpl_dp[$counter]["farbe"] = $tg["farbe"];
		$tpl_dp[$counter]["id"] = $e["id"];
		$tpl_dp[$counter]["datum"] = strftime($DATETIME["DdmY"], strtotime($e["startdatum"]));
		if($e["enddatum"] != $e["startdatum"] && $e["enddatum"] != "0000-00-00") {
			$tpl_dp[$counter]["datum"] .= " - ".strftime($DATETIME["DdmY"], strtotime($e["enddatum"]));
		}
		$tpl_dp[$counter]["zeit"] = substr($e["startzeit"], 0, -3);
		$tpl_dp[$counter]["room"] = $e["room"];
		$tpl_dp[$counter]["kommentar"] = $e["kommentar"];
		$tpl_dp[$counter]["kommentar2"] = $e["kommentar2"];

		//A header for each date
		if($tpl_dp[$counter]["datum"] != $dateheader) {
			$dateheader = $tpl_dp[$counter]["dateheader"] = $tpl_dp[$counter]["datum"];
		}

		//Vorlagen zu dieser Termingruppe
		for($i=0;$i<$max_templates;$i++) {
			//$v = ko_get_userpref($_SESSION["ses_userid"], $i, "dp_template_".$e["eventgruppen_id"]);
			//if($v)
			$tpl_dp[$counter]["template_open"][] = $e["eventgruppen_id"]."_$i";
			$tpl_dp[$counter]["template_save"][] = $e["eventgruppen_id"]."_$i";
		}//for(i=0..max_templates)


		//Alle anzuzeigenden Dienste
		$found_teams = FALSE;
		foreach($dienst as $d) {
			if($access['dp']['ALL'] < 1 && $access['dp'][$d] < 1) continue;

			$ad = $all_teams[$d];
			//Den Dienst nur anzeigen, wenn er fr diesen Event relevant ist.
			$tgs = explode(",",$ad["tg"]);
			if(!in_array($e["eventgruppen_id"], $tgs)) continue;  
			$found_teams = TRUE;

			//Dienst-Angaben speichern
			$tpl_dp[$counter]["dienste"][$d]["id"] = $d;
			$tpl_dp[$counter]["dienste"][$d]["dienstname"] = ko_html($ad["name"]);
			$tpl_dp[$counter]['dienste'][$d]['writable'] = (($access['dp']['ALL'] > 1 || $access['dp'][$d] > 1) && $monat_status == 1);
			$tpl_dp[$counter]['dienste'][$d]['readable'] = (($access['dp']['ALL'] > 0 || $access['dp'][$d] > 0) && $monat_status != 0);
			$spalten = (int)$ad["maxleute"];
			

			//Alle Leute zu diesem Dienst rausholen
			ko_get_leute_by_dienst($leute, $d);
			ko_get_einteilung($akt_leute, $d, $e["id"]);
			
			//und gemss den gemachten Angaben markieren
			$empty = TRUE;
			for($i=0; $i<$spalten; $i++) {
				if($akt_leute[$i]) {
					$tpl_dp[$counter]["dienste"][$d]["spalten"][$i] = $akt_leute[$i];
					$empty = FALSE;
				} else {
					$tpl_dp[$counter]["dienste"][$d]["spalten"][$i] = "";
				}
			}

			//Freetext anzeigen oder nicht
			$freetext = array();
			if(in_array($d, $freetext_dienste)) {
				$freetext["show"] = TRUE;
				//Nicht numerischen Wert aus aktueller Einteilung holen, das ist der Freetext
				$ft = array();
				foreach($akt_leute as $l) {
					if(!is_numeric($l)) $ft[] = $l;
				}
				if($access['dp']['ALL'] > 1 || $access['dp'][$d] > 1) $freetext['edit'] = TRUE;

				$freetext["value"] = implode(", ", $ft);
				$tpl_dp[$counter]["dienste"][$d]["freetext"] = $freetext;
			}

			//Speichern, ob schon jemand eingetragen ist
			$tpl_dp[$counter]["dienste"][$d]["leer"] = $empty;


			//Dienste, fr die das Login zustndig ist, markieren
			ko_get_leiter_by_dienst($leiter_ids, $d);
			$tpl_dp[$counter]["dienste"][$d]["verantwortlich"] = in_array(ko_get_logged_in_id(), $leiter_ids);

			$l_counter = 0;
			foreach($leute as $l_i => $l) {
				ko_get_person_by_id($l, $akt_person);

				if(ko_dp_check_double($l, $d, $e["id"])) {
					$tpl_dp[$counter]["dienste"][$d]["leute_output"][$l_counter] = ko_html("! ".$akt_person["vorname"]." ".$akt_person["nachname"]." !");
				} else {
					$tpl_dp[$counter]["dienste"][$d]["leute_output"][$l_counter] = ko_html($akt_person["vorname"]." ".$akt_person["nachname"]);
				}
				$tpl_dp[$counter]["dienste"][$d]["leute_values"][$l_counter] = $l;
				$l_counter++;
			}//foreach(leute)
		}//foreach(dienst)

		if($found_teams) {
			$counter++;
		} else {
			unset($tpl_dp[$counter]);
		}
	}//foreach(events)

	$titel = strftime($GLOBALS["DATETIME"]["MY"], mktime(1,1,1, (int)$_SESSION["show_monat"], 1, $_SESSION["show_jahr"]));
	$smarty->assign("tpl_titel", $titel);

	//LL-Values
	$smarty->assign("label_preset_save", getLL("dp_presets_save"));
	$smarty->assign("label_preset_save_globally", getLL("dp_presets_save_globally"));
	$smarty->assign("label_preset_save_confirm", getLL("dp_presets_save_confirm"));
	$smarty->assign("label_preset_insert", getLL("dp_presets_insert"));
	$smarty->assign("label_preset_insert_globally", getLL("dp_presets_insert_globally"));
	$smarty->assign("label_preset_insert_confirm", getLL("dp_presets_insert_confirm"));
	$smarty->assign("label_or", getLL("dp_freetext_or"));

	$smarty->assign("help", ko_get_help("dp", "show_dienst"));

	$smarty->assign("tpl_show_presets", (ko_get_setting("dp_use_presets") == 1));
	$smarty->assign("tpl_show_comment", ko_get_setting("dp_commentrow"));

	$smarty->assign("tpl_dp", $tpl_dp);
	if($output) {
		$smarty->display("ko_dp_erfassen.tpl");
	} else {
		print $smarty->fetch("ko_dp_erfassen.tpl");
	}
}//ko_show_dp()






function ko_list_dienste($output=TRUE) {
	global $access;

	if($access['dp']['MAX'] < 1) return;
	apply_dp_filter($z_where, $z_limit, TRUE);

	$rows = db_get_count("ko_dp_dienste", "id", $z_where);
	ko_get_dienste($_es, "", 'WHERE 1=1 '.$z_where, $z_limit);


	//Preprocess data:
	// - Don't include not to be shown teams
	// - Add status and leader columns
	$es = array();
	foreach($_es as $e_i => $e) {
		if($access['dp']['ALL'] < 1 && $access['dp'][$e_i] < 1) continue;

		$es[$e_i] = $e;

		//Verantwortlich
		ko_get_leiter_by_dienst($leiter, $e_i);
		if(sizeof($leiter) > 0) {
			foreach($leiter as $l) {
				ko_get_person_by_id($l, $p);
				$name = $p["vorname"]." ".substr($p["nachname"],0,1).".";
				if($p["email"]) {
					$name = '<a href="mailto:'.$p["email"].'">'.ko_html($p["vorname"]." ".$p["nachname"])."</a>";
				} else {
					$name = ko_html($p["vorname"]." ".$p["nachname"]);
				}
				$es[$e_i]["_leader"] .= "$name, ";
			}
			$es[$e_i]["_leader"] = substr($es[$e_i]["_leader"], 0, -2);
		} else {
			$es[$e_i]["_leader"] = "-";
		}

		//Status
		$todo = $done = 0;
		ko_get_dp_events($events, $_SESSION["show_monat"], $_SESSION["show_jahr"]);
		ko_get_dienste($dienst, $e_i);
		$tgs = explode(",", $dienst[$e_i]["tg"]);
		foreach($events as $event) {
			if(in_array($event["eventgruppen_id"], $tgs)) {
				$todo++;
				ko_get_einteilung($l, $e_i, $event["id"]);
				if(sizeof($l) > 0) $done++;
			}
		}//foreach(events)
		$es[$e_i]["_status"] = $done . " / " . $todo;
	}//foreach(es)


	$list = new kOOL_listview();

	$list->init("dp", "ko_dp_dienste", array("chk", "edit", "delete"), $_SESSION["show_start"], $_SESSION["show_limit"]);
	$list->setTitle(getLL("dp_list_title"));
	$list->setAccessRights(array('edit' => 3, 'delete' => 4), $access['dp']);
	$list->setActions(array("edit" => array("action" => "edit_dienst"),
													"delete" => array("action" => "delete_dienst", "confirm" => TRUE))
										);
	$list->setStats($rows);
	$list->setSort(FALSE);


	//Footer
	if($access['dp']['MAX'] > 3) {
		$list_footer[] = array("label" => getLL("dp_list_footer_reminder_label"),
													 "button" => '<input type="submit" name="submit_erinnern" onclick="set_action('."'dp_erinnern'".');" value="'.getLL("dp_list_footer_reminder_button").'" />');
	}

  $roster_code = '<select name="sel_dienst_erstellen_start" size="0">';
	$sel = '';
	$akt = add2date(date('Y-m-d'), 'monat', -1*ko_get_setting('dp_months_back'), TRUE);
	$code_akt = strftime('%Y%m', strtotime($akt));
	$rows = db_select_data('ko_dp_monat', "WHERE `sort` >= '$code_akt' AND `status` IN ('1', '2')");
	foreach($rows as $row) {
		$s = $code_akt == $row['sort'] ? 'selected="selected"' : '';
		$sel .= '<option value="'.$row["sort"].'" '.$s.'>'.$row["id"].'</option>';
	}
	$roster_code .= $sel;
	$roster_code .= '</select>&nbsp;&nbsp;-&nbsp;&nbsp;';
  $roster_code .= '<select name="sel_dienst_erstellen_stop" size="0">';
	$roster_code .= $sel;
	$roster_code .= '</select>&nbsp;&nbsp;';
   $roster_code .= '<input type="submit" name="submit_dienst_dp" onclick="set_action('."'dp_dienst_erstellen'".');" value="'.getLL('dp_list_footer_roster_button').'" /></td></tr>'; 

	$list_footer[] = array('label' => getLL('dp_list_footer_roster_label'),
												 'button' => $roster_code);

	$list->setFooter($list_footer);


	//Output the list
	if($output) {
		$list->render($es);
	} else {
		print $list->render($es);
	}
}//ko_list_dienste()





function ko_list_superdienste() {
	global $access;

	if($access['dp']['MAX'] < 4) return;

	$rows = db_get_count("ko_dp_superdienste", "id");
	ko_get_superdienste($es);

	$list = new kOOL_listview();

	$list->init("dp", "ko_dp_superdienste", array("chk", "edit", "delete"), $_SESSION["show_start"], $_SESSION["show_limit"]);
	$list->setTitle(getLL("dp_super_list_title"));
	$list->setAccessRights(FALSE);
	$list->setActions(array("edit" => array("action" => "edit_superdienst"),
													"delete" => array("action" => "delete_superdienst", "confirm" => TRUE))
										);
	$list->setStats($rows);
	$list->setSort(FALSE);
	$list->disableMultiedit;

	$list->render($es);
}//ko_list_superdienste()




function ko_formular_dienst($mode, $id="") {
	global $KOTA;

	if($mode == "new") {
		$id = 0;
	} else if($mode == "edit") {
		if(!$id) return FALSE;
	} else {
		return FALSE;
	}

	$form_data["title"] =  $mode == "new" ? getLL("form_dp_title_new") : getLL("form_dp_title_edit");
	$form_data["submit_value"] = getLL("save");
	$form_data["action"] = $mode == "new" ? "submit_new_dienst" : "submit_edit_dienst";
	$form_data["cancel"] = "list_dienste";

	ko_multiedit_formular("ko_dp_dienste", "", $id, "", $form_data);
}//ko_formular_dienst()



function ko_formular_superdienst($mode, $id="") {
	global $KOTA;

	if($mode == "new") {
		if($_POST["koi"]["ko_dp_superdienste"]["name"][0]) {
			kota_assign_values("ko_dp_superdienste", array("name" => $_POST["koi"]["ko_dp_superdienste"]["name"][0],
																										 "dienste" => $_POST["koi"]["ko_dp_superdienste"]["dienste"][0]
																										 ));
		}
		$id = 0;
	} else if($mode == "edit") {
		if(!$id) return FALSE;
	} else {
		return FALSE;
	}

	$form_data["title"] =  $mode == "new" ? getLL("form_dp_title_new_superteam") : getLL("form_dp_title_edit_superteam");
	$form_data["submit_value"] = getLL("save");
	$form_data["action"] = $mode == "new" ? "submit_new_superdienst" : "submit_edit_superdienst";
	$form_data["cancel"] = "list_superdienste";

	ko_multiedit_formular("ko_dp_superdienste", "", $id, "", $form_data);
}//ko_formular_superdienst()




/**
	* Erstellt Select-Code fr den Dienst-Filter fr das Leute-Modul
	*/
function ko_dp_create_dienstfilter() {
	ko_get_dienste($dienste);
	$save_string = '<select name="var1" size="0"><option value=""></option>';
	foreach($dienste as $d) {
		if($d["name"] && $d["id"]) $save_string .= '<option value="'.$d["id"].'">'.$d["name"].'</option>';
	}
	$save_string .= "</select>";

	//Dienst:
	db_update_data("ko_filter", "WHERE `typ`='leute' AND `name`='team'", array("code1" => $save_string));

	//Dienstleiter
	db_update_data("ko_filter", "WHERE `typ`='leute' AND `name`='team leader'", array("code1" => $save_string));

}//ko_dp_create_dienstfilter()




/**
	* Hebt eine Dienstzuweisung einer Person auf
	* Gibt FALSE zurck, falls die Person nicht bei diesem Dienst ist, oder der mode falsch war
	*/
function ko_dp_remove_person_from_dienst($p_id, $d_id, $mode) {
	ko_get_dienste($ad_, $d_id);
  $ad = $ad_[$d_id];

	ko_get_person_by_id($p_id, $person);

	if($mode == "dienst") {
		$string = "dienst";
	} else if ($mode == "dienstleiter") {
		$string = "dienstleiter";
	} else return FALSE;
	$p_dienste = explode(",", $person[$string]);

  if(!in_array($d_id, $p_dienste)) {
	  return FALSE;
  }

	$save_string = "";
	foreach($p_dienste as $d) {
		if($d != $d_id) {
			$save_string .= $d . ",";
		}
	}
	$save_string = substr($save_string, 0, -1);
	db_update_data("ko_leute", "WHERE `id`='$p_id'", array($string => $save_string));

	ko_log(("assign_".$string."_del"), $ad["name"]." (" . $d_id . "): ".$person["vorname"]." ".$person["nachname"]." ($p_id)");

	return TRUE;
}//ko_dp_remove_person_from_dienst()




/**
	* Weist eine Person einem Dienst zu.
	* Gibt FALSE zurck, falls die Person schon bei diesem Dienst ist, oder der mode falsch war
	*/
function ko_dp_assign_person_to_dienst($p_id, $d_id, $mode) {
	ko_get_dienste($ad_, $d_id);
  $ad = $ad_[$d_id];

	if($mode == "dienst") {
		$string = "dienst";
	} else if ($mode == "dienstleiter") {
		$string = "dienstleiter";
	} else return FALSE;

	ko_get_person_by_id($p_id, $person);
  $p_dienste = explode(",", $person[$string]);
  if(in_array($d_id, $p_dienste)) {
		return FALSE;
	}

	$save_string = $person[$string] . ($person[$string] != "" ? "," : "") . $d_id;
	db_update_data("ko_leute", "WHERE `id`='$p_id'", array($string => $save_string));

	ko_log(("assign_".$string), $ad["name"]." (" . $d_id . "): ".$person["vorname"]." ".$person["nachname"]." ($p_id)");

	return TRUE;
}//ko_dp_assign_person_to_dienst()




/**
	* Erstellt PDF des Dienstplanes
	*/
function ko_dp_create_pdf($monat, $jahr, $dienste, $p_id = 0, $fm=FALSE) {
	global $ko_path, $BASE_PATH, $DATETIME;

	ko_get_dp_events($events, $monat, $jahr);
	$do_sd = ko_get_setting("dp_superdienste");
	if($do_sd) ko_get_superdienste($superdienste);


	//PDF starten
	define('FPDF_FONTPATH',$BASE_PATH.'fpdf/schriften/');
	require_once($BASE_PATH.'fpdf/mc_table.php');
	$pdf=new PDF_MC_Table('L', 'mm', 'A4');
  $pdf->Open();
	$pdf->SetAutoPageBreak(true, 1);
	$pdf->AddFont('arial','','arial.php');
	$pdf->AddFont('arialb','','arialb.php');
	$pdf->AddPage();
	$pdf->calculateHeight(TRUE);
	$pdf->border(TRUE);
	$pdf->SetMargins(10,5,5);


	//Seiten-Dimensionen
	$seiten_breite = 297 - 15;
	$seiten_hoehe  = 210 - 10;
	$col_w = (int)($seiten_breite / (sizeof($events)+1));
	$cols = array();
	for($i=0; $i<(sizeof($events)+1); $i++) {
		$cols[] = $col_w;
	}


	$pdf->SetWidths($cols);  //Spaltenbreiten
	$font_size = ko_get_setting("dp_fontsize");
	if(!$font_size) $font_size = 11;
	$pdf->SetFont('arial', '', $font_size);
	$pdf->SetZeilenhoehe(0.4*$font_size);


	//Titelzeile mit allen Eventnamen
	$titel_aligns = array();
	$titel_aligns[] = "C";
	$titel_fills = array();
	$titel_fills[] = 0;

	$titel_colors = array();
	$titel_colors[] = "ffffff";
	$titel_text_colors = array();
	$titel_text_colors[] = "000000";

	$comment_aligns = array();
	$comment_aligns[] = "L";

	$text_aligns = array();
	$text_aligns[] = "L";

	$titelzeile = array();
	$titelzeile[] = ((ko_get_setting("dp_titel")&&!$fm)?ko_get_setting("dp_titel"):(getLL("dp_roster")."\n".$monat."-".$jahr));

	//Get list separator setting
	$list_separator = strtr(ko_get_setting('dp_list_separator'), array('<br />' => "\n", '<br>' => "\n"));

	ko_get_eventgruppen($eventgroups);

	//Add comment row's title
	$commentrow = ko_get_setting("dp_commentrow");
	if($commentrow) {
		if($commentrow == "both") $commentrow = array("kommentar", "kommentar2");
		else $commentrow = array($commentrow);
	}
	$comments = array();
	foreach($commentrow as $i => $crow) $comments[$i][] = getLL("kota_ko_event_".$crow);

	foreach($events as $e) {
		ko_get_eventgruppe_by_id($e["eventgruppen_id"], $grp);
		if(defined("DP_HEADER_FORMAT")) {
			$e_titel = strtr(DP_HEADER_FORMAT, array("DATE" => sql2datum($e["startdatum"]), "TIME" => substr($e["startzeit"], 0, -3), "OCLOCK" => getLL("time_oclock"), "EG_NAME" => $grp["name"], "ROOM" => $e["room"]));
		} else {
			$e_titel  = sql2datum($e["startdatum"])."\n";
			$e_titel .= $grp["name"]."\n";
			$e_titel .= substr($e["startzeit"], 0, -3)." ".getLL("time_oclock");
		}
		$titelzeile[] = $e_titel;

		$titel_aligns[] = "C";
		$text_aligns[] = "L";
		$titel_fills[] = 1;
		$bg_color = $eventgroups[$e["eventgruppen_id"]]["farbe"] ? $eventgroups[$e["eventgruppen_id"]]["farbe"] : "FFFFFF";
		$text_color = ko_get_setting("dp_use_colors") == 0 ? "000000" : ko_get_contrast_color($bg_color, '000000', 'ffffff');
		$titel_colors[] = $bg_color;
		$titel_text_colors[] = $text_color;

		//Comment row
		if($commentrow) {
			foreach($commentrow as $i => $crow) {
				$comments[$i][] = $e[$crow];
				$comment_aligns[] = "L";
			}
		}
	}//foreach(events)

	//Draw title row
	if(ko_get_setting("dp_use_colors") == 1) $pdf->SetFillColors($titel_colors);
	else $pdf->SetFillColor(200);
	$pdf->SetFills($titel_fills);
	$pdf->SetTextColors($titel_text_colors);
	$pdf->SetAligns($titel_aligns);
	$pdf->SetFont('arialb', '', $font_size-1);
	$pdf->Row($titelzeile);

	//Add comment rows
	$pdf->SetFont('arial', '', $font_size-1);
	if($commentrow) {
		$pdf->SetAligns($comment_aligns);
		foreach($comments as $i => $crow) $pdf->Row($crow);
	}
	//Reset normal font
	$pdf->SetFont('arial', '', $font_size);
	$pdf->UnsetFillColors();
	$pdf->UnsetTextColors();


	$namenformat = ko_get_setting("dp_namenformat");
	$mark_empty  = ko_get_setting("dp_mark_empty");

	//Dienste-IDs der zu verwendenen Dienste
	$dienste_ids = array_keys($dienste);


	//Eigentliche Daten ausgeben
	$pdf->SetFillColor(200);
	//Set text color back to black
	$pdf->UnsetTextColors();
	$pdf->SetTextColor(0);
	$pdf->SetAligns($text_aligns);
	$dienste_done = array();
	foreach($dienste as $d) {
		//Falls Dienst schon von Dienstgruppe eines anderen Dienstes gemacht wurde, diesen berspringen
		if($do_sd && in_array($d["id"], $dienste_done)) continue;

		$fills = array();
		$fills[] = 1;  //Mark first column containing the team's name
		
		unset($dienst_id); $sd_found = FALSE;
		if($do_sd) {
			foreach($superdienste as $sd) {
				$sd_dienste = explode(",", $sd["dienste"]);
				if(in_array($d["id"], $sd_dienste)) {
					$sd_found = TRUE;
					foreach($sd_dienste as $sd_dienst) {
						if(in_array($sd_dienst, $dienste_ids)) $dienst_id[] = $sd_dienst;  //Nur Dienste aus Dienstgruppe nehmen, die verwendet werden sollen.
					}
					$dienste_done = array_merge($dienste_done, $dienst_id);
					$dienst_name = $sd["name"];
				}
			}
			if(!$sd_found) {  //Falls dieser Dienst in keine Dienstgruppe auftacht, einfach Dienst verwenden
				$dienst_id = $d["id"];
				$dienst_name = $d["name"];
			}
		} else {
			$dienst_id = $d["id"];
			$dienst_name = $d["name"];
		}

		//Dienstname
		$zeile = array();
		$zeile[] = $dienst_name;

		foreach($events as $e) {
			$txt = "";
			$fill_this = 0;
			//Check whether this team ministers in this event
			if(in_array($e["eventgruppen_id"], explode(",", $d["tg"]))) {
				ko_get_einteilung($la, $dienst_id, $e["id"]);
				//Fill an array with all the people to join with the list separator afterwards
				$people = array();
				foreach($la as $l) {  //Alle Leute auslesen
					if(!$l) continue;

					if(is_numeric($l)) {
						if($l == $p_id) $fill_this = 1;  //Zelle der gewnschten Person grau hinterlegen

						ko_get_person_by_id($l, $p);
						switch($namenformat) {
							case 1:
								$people[] = $p["vorname"]." ".substr($p["nachname"],0,1).".";
							break;
							case 2:
								$people[] .= $p["vorname"]." ".substr($p["nachname"],0,2).".";
							break;
							case 3:
								$people[] .= substr($p["vorname"],0,1).". ".$p["nachname"];
							break;
							case 4:
								$people[] .= $p["vorname"]." ".$p["nachname"];
							break;
							case 5:
								$people[] .= $p["vorname"];
							break;
						}//switch($namenformat)
					}
					else {  //Freetext-Eintrag
						$people[] .= $l." ";
					}
				}
				//Join people with list separator
				$txt = implode($list_separator, $people).' ';
			} else {  //mark events for this team with a "-" if it is not ministring then
				$txt = "- ";
			}
			$fills[] = $fill_this;
			$zeile[] = ($txt) ? substr($txt, 0, -1) : ($mark_empty ? getLL("dp_empty") : "");
		}//foreach(events)

		$pdf->SetFills($fills);
		$pdf->Row($zeile);

	}//foreach(dienste)

	//Add creation date
	$pdf->SetFont('arial', '', 9);
	$pdf->SetFillColor(0);
	$text = getLL("res_info_cdate").": ".strftime($DATETIME["dMY"], time());
	$pdf->Text($seiten_breite + 8 - $pdf->getStringWidth($text), 9, $text);

	$filename = $ko_path."download/pdf/".getLL("dp_filename_dp").strftime("%d%m%Y_%H%M%S", time()).".pdf";
	$pdf->Output($filename);
	return $filename;

}//ko_dp_create_pdf()



/**
	* Zeigt alle Einstellungen rund um das Erstellen und Versenden des DPs an
	*/
function ko_dp_show_create_dp($send_info = "", $output=TRUE) {
	global $smarty, $ko_path;

	//Einstellungen anzeigen
  $smarty->assign("tpl_titel", getLL("dp_settings_title"));

  $parts[0]["titel"] = getLL("dp_settings_dp");
	$setting[0]["desc"] = getLL("dp_settings_dp_titel");
	$setting[0]["type"] = "text";
	$setting[0]["params"] = 'size="40"';
	$setting[0]["name"] = "txt_titel";
	$setting[0]["value"] = ko_html(ko_get_setting("dp_titel"));

	$setting[1]["desc"] = getLL("dp_settings_dp_fontsize");
	$setting[1]["type"] = "select";
	$setting[1]["name"] = "sel_fontsize";
	$setting[1]["values"] = array(8,9,10,11,12,13,14,15,16);
	$setting[1]["descs"] = array(8,9,10,11,12,13,14,15,16);
	$setting[1]["value"] = ko_html(ko_get_setting("dp_fontsize"));

	$setting[2]["desc"] = getLL("dp_settings_dp_namen");
	$setting[2]["type"] = "select";
	$setting[2]["name"] = "sel_namen";
	$setting[2]["values"] = array(1,2,3,4,5);
	$setting[2]["descs"] = array(getLL("dp_settings_dp_namen_1"), getLL("dp_settings_dp_namen_2"), getLL("dp_settings_dp_namen_3"), getLL("dp_settings_dp_namen_4"), getLL("dp_settings_dp_namen_5"));
	$setting[2]["value"] = ko_html(ko_get_setting("dp_namenformat"));

	$setting[3]["desc"] = getLL("dp_settings_dp_dienste");
	$setting[3]["type"] = "radio";
	$setting[3]["name"] = "rd_dienste";
	$setting[3]["value"] = array(1,2);
	$setting[3]["output"] = array(getLL("all"), getLL("selected"));
	$setting[3]["checked"] = ko_html(ko_get_setting("dp_dienste"));

	$setting[4]["desc"] = getLL("dp_settings_dp_mark_empty");
	$setting[4]["type"] = "radio";
	$setting[4]["name"] = "rd_mark_empty";
	$setting[4]["value"] = array(1,0);
	$setting[4]["output"] = array(getLL("yes"), getLL("no"));
	$setting[4]["checked"] = ko_html(ko_get_setting("dp_mark_empty"));

	$setting[5]["desc"] = getLL("dp_settings_dp_list_separator");
	$setting[5]["type"] = "text";
	$setting[5]["params"] = 'size="5"';
	$setting[5]["name"] = "txt_dp_list_separator";
	$setting[5]["value"] = ko_html(ko_get_setting("dp_list_separator"));
		
	
	$parts[0]["settings"] = $setting;

	$smarty->assign("help", ko_get_help("dp", "create_dp_settings"));
	$smarty->assign("tpl_parts", $parts);
	$smarty->assign("tpl_action", "save_create_dp");

	$smarty->display("ko_settings.tpl");


  //Erstellen
	$smarty->assign("tpl_titel", getLL("dp_create_title"));

	
	$content = '<table>
		<tr><td><b>'.getLL("dp_create_neutral").'</b></td>
		<td><input type="submit" onclick="set_action('."'".'do_create_dp_neutral'."'".')" value="'.getLL("dp_create").'" /></td></tr>
		<tr><td><b>'.getLL("dp_create_personal").'</b></td>
		<td><select id="sel_dp_person" name="sel_dp_person" onchange="toggleSendButton();" size="0">';
	
	//Get all team members and leaders for the people select for the personal rota plan
	ko_get_dienste($dienste);
	$persons = array();
	foreach($dienste as $dienst) {
		ko_get_leute_by_dienst($leute, $dienst["id"]);
		ko_get_leiter_by_dienst($leiter, $dienst["id"]);
		$persons = array_merge($persons, $leute, $leiter);
	}
	$persons = array_unique($persons);
	//Sorting from setting
	$orderby = ko_get_setting("dp_orderby");
	if(!$orderby) $orderby = "vorname";
	$orderby = $orderby == "vorname" ? "`vorname` ASC, `nachname` ASC" : "`nachname` ASC, `vorname` ASC";
	$rows = db_select_data("ko_leute", "WHERE deleted = 0 AND `id` IN ('".implode("','", $persons)."')", array("id", "vorname", "nachname", "email"), "ORDER BY $orderby");
	foreach($rows as $row) {
		$class = ($row['email'] ? 'has_email' : 'no_email');
		$content .= '<option class="'.$class.'" value="'.$row["id"].'">'.$row["vorname"]." ".$row["nachname"].'</option>';
	}
	$content .= '</select>';
	
	//Buttons to create and send single rotas
	$content .= '&nbsp;&nbsp;&nbsp;';
	$content .= '<input type="submit" onclick="set_action('."'".'do_create_dp'."'".')" value="'.getLL("dp_create").'" />';
	$content .= '&nbsp;&nbsp;&nbsp;';
	$content .= '<input id="dpSendButton" type="submit" onclick="c = confirm(\''.getLL('dp_createsend_confirm').'\'); if(c) {set_action('."'".'do_createsend_dp'."'".');} else { return false; }" value="'.getLL("dp_createsend").'" />';

	//attach JS to handle onChange event:
	$content .= '<script type="text/javascript">'
					 .'var selectmenu=document.getElementById("sel_dp_person");'
				   .'selectmenu.onchange = function(){ '
				   .'  var myOption = this.options[this.selectedIndex];'
				   .'  document.getElementById("dpSendButton").disabled = (myOption.className == "no_email");'
				   .' }; '
				   .'selectmenu.onchange();'
					 .'</script>'; 			   
			   
	$content .= '</td></tr>';

	$content .= '<tr><td><b>'.getLL("dp_create_fm").'</b></td><td>';
	//Erlaubte IDs erstellen
  get_heute($t, $m, $j);
  $ids[1] = str_to_2($m)."-".$j;
  addmonth($m, $j, 1);
  $ids[2] = str_to_2($m)."-".$j;
	
	for($i = 1; $i<=2; $i++) {
		$id = $ids[$i];
		if(ko_dp_get_monat_status($id) == 2) {
			if(file_exists($ko_path."download/dp/".getLL("dp_filename_dp").$id.".pdf")) {
				$file_link = $ko_path."download/dp/".getLL("dp_filename_dp").$id.".pdf";
			} else {
				$file_link = "";
			}
			$content .= $file_link ? '<a href="'.$file_link.'">' : '';
			$content .= $id;
			$content .= $file_link ? '</a>' : '';
			$content .= '&nbsp;&nbsp;<input type="image" src="'.$ko_path.'images/create_pdf.png" onclick="set_action('."'do_create_dp_fm'".');set_hidden_value('."'id', '".$id."'".');this.submit;" title="'.getLL("dp_create_fm").'" />&nbsp;&nbsp;&nbsp;&nbsp;';
		} else {
			$content .= $id;
			$content .= '&nbsp;&nbsp;<img src="'.$ko_path.'images/create_pdf_disabled.png" title="'.getLL("dp_create_fm_close").'" />&nbsp;&nbsp;&nbsp;&nbsp;';
		}
	}


	$content .= '</td></tr>';

	$content .= '</table>';

	$smarty->assign("help", ko_get_help("dp", "create_dp"));
	$smarty->assign("tpl_content", $content);
	$smarty->assign("tpl_top", "<br /><br />");
	$smarty->assign("tpl_below", "");

	$smarty->display("ko_subpart.tpl");


  //Versand
	$smarty->assign("tpl_titel", getLL("dp_send_title"));
	if($send_info) {
		$content = '<div class="infotxt">'.$send_info.'</div><br />';
	} else {
		$content = "";
	}
	$content .= '<table><tr><td><b>'.getLL("dp_send_subject").'</b></td>
		<td><input type="text" size="40" name="txt_betreff" value="'.getLL("dp_roster").' '.strftime($GLOBALS["DATETIME"]["MY"], mktime(1,1,1, $_SESSION["show_monat"], 1, $_SESSION["show_jahr"])).'" /></td></tr>
		<tr><td valign="top"><b>'.getLL("dp_send_recipients").'</b></td>
		<td><input type="radio" name="rd_rec_dienste" value="1"/>'.getLL("all").'&nbsp;&nbsp;
		<input type="radio" name="rd_rec_dienste" value="2" checked="checked" />'.getLL("selected").'</td></tr>
		<tr><td valign="top"><b>'.getLL("dp_send_mailtext").'</b></td>
		<td><textarea name="txt_mailtext" cols="60" rows="10">'.ko_get_setting("dp_mailtext_2").'</textarea></td></tr>
		<tr><td>&nbsp;</td>
		<td><br /><input type="submit" value="'.getLL("dp_send_submit").'" onclick="set_action('."'do_send_dp'".')" /></td></tr>
		</table>';

	$smarty->assign("help", "");
	$smarty->assign("tpl_content", $content);
	$smarty->assign("tpl_top", "<br /><br />");
	$smarty->assign("tpl_below", "");

	if($output) {
		$smarty->display("ko_subpart.tpl");
	} else {
		print $smarty->fetch("ko_subpart.tpl");
	}
}//ko_dp_show_create_dp()




function ko_dp_create_dienste_pdf($dienste_, $monate) {
	global $ko_path, $BASE_PATH, $DATETIME;

	//PDF starten
  define('FPDF_FONTPATH',$BASE_PATH.'fpdf/schriften/');
  require($BASE_PATH.'fpdf/mc_table.php');
  $pdf=new PDF_MC_Table('P', 'mm', 'A4');
  $pdf->Open();
  $pdf->SetAutoPageBreak(true, 1);
  $pdf->AddFont('arial','','arial.php');
	$pdf->AddFont('arialb','','arialb.php');
  $pdf->AddPage();
  $pdf->calculateHeight(TRUE);
  $pdf->border(TRUE);
  $pdf->SetMargins(10,5,5);

	$PDF_fontsize_header = 12;
	$PDF_fontsize_event = 11;
	$PDF_fontsize_einteilung = ko_get_setting('dp_fontsize');
  if(!$PDF_fontsize_einteilung) $PDF_fontsize_einteilung = 9;

	$PDF_space_row = 4;
	$PDF_space_title = 1.5;
	$PDF_space_after_table = 6;
	$PDF_rand_rechts = 10;

	$PDF_page_start = 10;
	$PDF_page_end = 277;


	$freetext_dienste = explode(",", ko_get_setting("dp_freetext_dienste"));
	$max_cols = 1;
	foreach($dienste_ as $d_) {
		ko_get_dienste($d__, $d_);
		$d = $d__[$d_];
		$dienste[$d["id"]] = $d;
		//Spaltenanzahl aus Max-Leute
		$num = $d["maxleute"];
		if(in_array($d["id"], $freetext_dienste)) $num++;
		$max_cols = max($max_cols, $num);
		//Eventgruppen
		$temp = explode(",", $d["tg"]);
		foreach($temp as $t) {
			$tgs[] = $t;
		}
	}
	//Eventgruppen, die fr die gewhlten Dienste relevant sind
	$tgs = array_unique($tgs);

	//Anzahl Spalten herausfinden
	$width = 190/($max_cols+1);
	for($i=0; $i<($max_cols+1); $i++) {
		$cols[] = $width;
	}
	$pdf->SetWidths($cols);


	$PDF_y = $PDF_page_start;


	//Header ausgeben
	$header = getLL("dp_roster")." ";
	if(sizeof($monate) == 1) {
		$header .= $monate[0];
	} else {
		$header .= $monate[0]." - ".$monate[sizeof($monate)-1];
	}
	$pdf->SetFont('arialb', '', $PDF_fontsize_header);
	$pdf->Text($PDF_rand_rechts, $PDF_y, $header);

	//Add logo
	$logo = ko_get_pdf_logo();
	if($logo) {
		$pic = getimageSize($ko_path.'my_images/'.$logo);
		$picWidth = 15 / $pic[1] * $pic[0];
		$pdf->Image($ko_path.'my_images/'.$logo, 200-$picWidth, 5, $picWidth);
	}


	//Add creation date
	$pdf->SetFont('arial', '', 9);
	$pdf->SetFillColor(0);
	$text = getLL("res_info_cdate").": ".strftime($DATETIME["dMY"], time());
	$pdf->Text(200 - $pdf->getStringWidth($text), 292, $text);

	$PDF_y += 10;

	$commentrow = ko_get_setting("dp_commentrow");
	if($commentrow) {
		if($commentrow == "both") $commentrow = array("kommentar", "kommentar2");
		else $commentrow = array($commentrow);
	}
	
	//Durch alle Monate durchgehen
	foreach($monate as $m) {
		list($monat, $jahr) = explode("-", $m);
		ko_get_dp_events($events, $monat, $jahr);
		foreach($events as $e_i => $e) {
			if(!in_array($e["eventgruppen_id"], $tgs)) continue;

			//Anlass
			ko_get_eventgruppe_by_id($e["eventgruppen_id"], $tg);
			$pdf->SetFont('arialb', '', $PDF_fontsize_event);
			$title  = strftime($GLOBALS["DATETIME"]["dMY"], strtotime($e["startdatum"]));
			$title .= ", ".$tg["name"];
			$title .= " (".substr($e["startzeit"], 0, -3).")";

			//Seitenumbruch
			if(($PDF_y+sizeof($dienste)*$PDF_space_row) > $PDF_page_end) {
				$pdf->AddPage();
				$PDF_y = $PDF_page_start;
				$pdf->setY($PDF_y);
			}

			$pdf->Text($PDF_rand_rechts, $PDF_y, $title);

			//Add comment
			$comment = "";
			foreach($commentrow as $crow) {
				if($e[$crow]) $comment .= $e[$crow]." / ";
			}
			if($comment != "") {
				$PDF_y += 2*$PDF_space_title;
				$pdf->SetFont('arial', '', $PDF_fontsize_einteilung);
				$pdf->Text($PDF_rand_rechts, ($PDF_y+0.5*$PDF_space_title), ("  ".substr($comment, 0, -3)) );
			}

			//Einteilungen
			$pdf->setY($PDF_y + $PDF_space_title);
			$pdf->SetFont('arial', '', $PDF_fontsize_einteilung);
			foreach($dienste as $d) {
				//Dienst nur anzeigen, wenn er fr diese TG aktiv ist
				$d_tgs = explode(",", $d["tg"]);
				if(!in_array($e["eventgruppen_id"], $d_tgs)) continue;
				
				//Einteilung auslesen und in einzelnen Spalten ausgeben
				ko_get_einteilung($leute, $d["id"], $e["id"]);
				for($i=0; $i<($max_cols+1); $i++) $row[$i] = " ";
				$row[0] = $d["name"];
				$l_count = 0;
				foreach($leute as $l) {
					if(is_numeric($l)) {
						ko_get_person_by_id($l, $p);
						$row[++$l_count] = $p["vorname"]." ".$p["nachname"];
					} else {
						$row[++$l_count] = $l;
					}
				}
				$pdf->Row($row);
				
				//$PDF_y += $PDF_space_row;
			}//foreach(dienste)
			$PDF_y = $pdf->GetY() + $PDF_space_after_table;
		}//foreach(events)

	}//foreach(monate as m)

	$pdf_filename = $ko_path."download/pdf/".getLL("dp_filename_dp_teams").strftime("%d%m%Y_%H%M%S", time()).".pdf";
  $pdf->Output($pdf_filename, false);

	return $pdf_filename;
}//ko_dp_create_dienste_pdf()





/**
	* Zeigt alle diverse Einstellungen
	*/
function ko_dp_show_settings_div() {
	global $smarty;
	global $access;

	if($access['dp']['MAX'] < 4) return FALSE;

	//Einstellungen anzeigen
  $smarty->assign("tpl_titel", getLL("dp_misc_title"));


	//Groups
	ko_get_grouproles($roles);
	$values = array("");
	$descs = array("");
	foreach($roles as $id => $role) {
		$values[] = $id;
		$descs[] = $role["name"];
	}
	$setting = array();
	$parts[0]['titel'] = getLL('dp_misc_group_title');
  $setting[0]['desc'] = getLL('dp_misc_group_showroles');
	$setting[0]['type'] = 'select';
	$setting[0]['name'] = 'sel_group_showroles';
	$setting[0]['values'] = array('1', '0');
	$setting[0]['descs'] = array(getLL('yes'), getLL('no'));
	$setting[0]['value'] = ko_get_setting('dp_showroles');

	$params = ko_get_setting('dp_showroles') == 1 ? 'disabled="disabled"' : '';
  $setting[1]['desc'] = getLL('dp_misc_group_teamrole');
	$setting[1]['type'] = 'select';
	$setting[1]['name'] = 'sel_group_teamrole';
	$setting[1]['values'] = $values;
	$setting[1]['descs'] = $descs;
	$setting[1]['value'] = ko_get_setting('dp_teamrole');
	$setting[1]['params'] = $params;

  $setting[2]['desc'] = getLL('dp_misc_group_leaderrole');
	$setting[2]['type'] = 'select';
	$setting[2]['name'] = 'sel_group_leaderrole';
	$setting[2]['values'] = $values;
	$setting[2]['descs'] = $descs;
	$setting[2]['value'] = ko_get_setting('dp_leaderrole');

  $setting[3]['desc'] = getLL('dp_misc_group_orderby');
	$setting[3]['type'] = 'select';
	$setting[3]['name'] = 'sel_group_orderby';
	$setting[3]['values'] = array('vorname', 'nachname');
	$setting[3]['descs'] = array(getLL('dp_misc_group_orderby_vorname'), getLL('dp_misc_group_orderby_nachname'));
	$setting[3]['value'] = ko_html(ko_get_setting('dp_orderby'));

  $setting[4]['desc'] = getLL('dp_misc_group_presets');
	$setting[4]['type'] = 'select';
	$setting[4]['name'] = 'sel_group_presets';
	$setting[4]['values'] = array('1', '0');
	$setting[4]['descs'] = array(getLL('yes'), getLL('no'));
	$setting[4]['value'] = ko_get_setting('dp_use_presets');

  $setting[5]['desc'] = getLL('dp_misc_group_commentrow');
	$setting[5]['type'] = 'select';
	$setting[5]['name'] = 'sel_group_commentrow';
	$setting[5]['values'] = array('', 'kommentar', 'kommentar2', 'both');
	$setting[5]['descs'] = array('', getLL('kota_ko_event_kommentar'), getLL('kota_ko_event_kommentar2'), getLL('both'));
	$setting[5]['value'] = ko_get_setting('dp_commentrow');

  $setting[6]['desc'] = getLL('dp_misc_group_use_colors');
	$setting[6]['type'] = 'select';
	$setting[6]['name'] = 'sel_group_use_colors';
	$setting[6]['values'] = array('1', '0');
	$setting[6]['descs'] = array(getLL('yes'), getLL('no'));
	$setting[6]['value'] = ko_get_setting('dp_use_colors');

  $setting[7]['desc'] = getLL('dp_misc_months_back');
	$setting[7]['type'] = 'select';
	$setting[7]['name'] = 'sel_months_back';
	$setting[7]['values'] = array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24);
	$setting[7]['descs'] = array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24);
	$setting[7]['value'] = ko_get_setting('dp_months_back');

	$parts[0]['settings'] = $setting;


	//Dienste, bei denen Freetext bei der Einteilung angezeigt werden sollen
	ko_get_dienste($alle_dienste);
	$values = $descs = array();
	foreach($alle_dienste as $d) {
		$values[] = $d["id"];
		$descs[] = $d["name"];
	}
	$freetext_dienste = ko_get_setting("dp_freetext_dienste");
	foreach(explode(",", $freetext_dienste) as $d) {
		if($d) {
			$avalues[] = $d;
			$adescs[] = $alle_dienste[$d]["name"];
		}
	}
	$setting = array();
	$parts[1]["titel"] = getLL("dp_misc_freetext_title");
  $setting[0]["desc"] = getLL("help");
	$setting[0]["type"] = "html";
	$setting[0]["value"] = getLL("dp_misc_freetext_help");

  $setting[1]["desc"] = getLL("dp_misc_freetext_teams");
	$setting[1]["type"] = "doubleselect";
	$setting[1]["name"] = "sel_freetext_dienste";
	$setting[1]["values"] = $values;
	$setting[1]["descs"] = $descs;
	$setting[1]["avalue"] = implode(",", $avalues);
	$setting[1]["avalues"] = $avalues;
	$setting[1]["adescs"] = $adescs;
	$setting[1]["params"] = 'size="7"';

	$parts[1]["settings"] = $setting;


	//Mailtexts
  $parts[2]["titel"] = getLL("dp_misc_mail_title");
  $setting[0]["desc"] = getLL("dp_misc_mail_reminder");
  $setting[0]["type"] = "textarea";
	$setting[0]["params"] = 'cols="60" rows="10"';
	$setting[0]["name"] = "txt_mail1";
	$setting[0]["value"] = ko_html(ko_get_setting("dp_mailtext_1"));

  $setting[1]["desc"] = getLL("dp_misc_mail_roster");
  $setting[1]["type"] = "textarea";
	$setting[1]["params"] = 'cols="60" rows="10"';
	$setting[1]["name"] = "txt_mail2";
	$setting[1]["value"] = ko_html(ko_get_setting("dp_mailtext_2"));

	$parts[2]["settings"] = $setting;


	//Deadline
	$setting = array();
	$parts[3]["titel"] = getLL("dp_misc_deadline_title");
  $setting[0]["desc"] = getLL("dp_misc_deadline_week");
	$setting[0]["type"] = "select";
	$setting[0]["name"] = "sel_deadline_woche";
	$setting[0]["values"] = array(1,2,3,4);
	$setting[0]["descs"] = array(getLL("dp_misc_deadline_week_1"), getLL("dp_misc_deadline_week_2"), getLL("dp_misc_deadline_week_3"), getLL("dp_misc_deadline_week_4"));
	$setting[0]["value"] = ko_html(ko_get_setting("dp_deadline_woche"));

  $setting[1]["desc"] = getLL("dp_misc_deadline_day");
	$setting[1]["type"] = "select";
	$setting[1]["name"] = "sel_deadline_tag";
	$setting[1]["values"] = array(1,2,3,4,5,6,0);
	//Day of the week
	$monday = date_find_last_monday(date("Y-m-d"));
	for($i=0; $i<7; $i++) $weekdays[] = strftime("%A", strtotime(add2date($monday, "tag", $i, TRUE)));
	$setting[1]["descs"] = $weekdays;
	$setting[1]["value"] = ko_html(ko_get_setting("dp_deadline_tag"));

	$parts[3]["settings"] = $setting;


	//Superteams
	$setting = array();
	$parts[4]["titel"] = getLL("dp_misc_superteam_title");
  $setting[0]["desc"] = getLL("dp_misc_superteam_use");
	$setting[0]["type"] = "radio";
	$setting[0]["name"] = "rd_superdienste";
	$setting[0]["value"] = array(0, 1);
	$setting[0]["output"] = array(getLL("no"), getLL("yes"));
	$setting[0]["checked"] = ko_html(ko_get_setting("dp_superdienste"));

	$parts[4]["settings"] = $setting;


	$smarty->assign("tpl_parts", $parts);
	$smarty->assign("tpl_action", "submit_dp_settings_div");

	$smarty->display("ko_settings.tpl");
}//ko_dp_show_settings_div()



/**
	* DP-Filter und -Limit anwenden
	*/
function apply_dp_filter(&$z_where, &$z_limit, $do_where = FALSE) {
	global $access;

	$z_where = "";
	if($do_where) {
		foreach($_SESSION["show_dienste"] as $d) {
			if($access['dp']['ALL'] > 0 || $access['dp'][$d] > 0) $z_where .= " `id` = '$d' OR ";
		}
	}
	if($z_where) $z_where = " AND (".substr($z_where, 0, -3).") ";

	//Limit bestimmen
  $z_limit = "LIMIT " . ($_SESSION["show_start"]-1) . ", " . $_SESSION["show_limit"];
}//apply_dp_filter()




function ko_dp_send_email($dienste, $p, $email, $betreff, $mailtext) {
	$filename = ko_dp_create_pdf($_SESSION['show_monat'], $_SESSION['show_jahr'], $dienste, $p['id']);

	if(defined('DEBUG_EMAIL') && DEBUG_EMAIL) {
		print '<h2>Email sent</h2>';
		print 'From: '.ko_get_setting('info_email').'<br />';
		print '<b>To: '.ko_html($email).'</b><br />';
		print '<b>Subject: '.ko_html($betreff).'</b><br />';
		print '<hr>'.nl2br($mailtext).'<hr>';
		print 'Attachment: <a href="'.$filename.'">'.$filename.'</a><br />';
	} else {
		$fp = fopen($filename, 'r');
		$attachment = fread($fp, filesize($filename));
		fclose($fp);
		$mail_dp = new mime_mail();
		$mail_dp->from = 'kOOL <'.ko_get_setting('info_email').'>';
		if(defined('EMAIL_SET_RETURN_PATH') && EMAIL_SET_RETURN_PATH == TRUE) $mail_dp->headers = 'Return-Path: <'.ko_get_setting('info_email').'>';
		$mail_dp->to = $email;
		$mail_dp->subject = $betreff;
		$mail_dp->body = $mailtext;
		$mail_dp->add_attachment($attachment, 'dienstplan_'.$_SESSION['show_jahr'].'-'.$_SESSION['show_monat'].'.pdf', 'application/pdf');
		$ok = $mail_dp->send();
		unset($mail_dp);
	}
	return $ok; 
}



function ko_dp_get_personlist($str) {
	$_ids = explode(',', $str);
	$ids = $texts = array();
	foreach($_ids as $id) {
		$id = trim($id);
		if(intval($id) == $id && $id != 0) $ids[] = $id;
		else $texts[] = $id;
	}
	$names = array();
	$persons = db_select_data('ko_leute', "WHERE `id` IN ('".implode("','", $ids)."')");
	foreach($persons as $p) {
		$names[] = $p['vorname'].' '.$p['nachname'];
	}

	$value = '';
	if(sizeof($names) > 0) $value .= implode(', ', $names);
	if(sizeof($texts) > 0) $value .= ($value != '' ? ', ' : '').implode(', ', $texts);
	return $value;
}//ko_dp_get_personlist()


?>
