<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2011 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

if(in_array('ko_event', $KOTA_TABLES)) {
	$KOTA['ko_event'] = array(
		'_access' => array(
			'module' => 'daten',
			'chk_col' => 'eventgruppen_id',
		),
		"_multititle" => array(
			"eventgruppen_id" => "ko_get_eventgruppen_name('@VALUE@')",
			"startdatum" => "sql2datum('@VALUE@')",
			"startzeit" => "sql_zeit('@VALUE@')",
		),
		"_listview" => array(
			10 => array("name" => "startdatum", "sort" => "startdatum", "multiedit" => "startdatum,enddatum"),
			20 => array("name" => "eventgruppen_id", "sort" => "eventgruppen_id"),
			30 => array("name" => "kommentar", "sort" => "kommentar"),
			//35 for kommentar2 if not ko_guest
			40 => array("name" => "startzeit", "sort" => "startzeit", "multiedit" => "startzeit,endzeit"),
			50 => array("name" => "room", "sort" => "room"),
			//60 is reserved for rota (set further down) only if rota module is installed
			//70 is reserved for reservations (set further down) only if res module is installed
		),
		"eventgruppen_id" => array(
			"list" => 'db_get_column("ko_eventgruppen", @VALUE@, "name")',
			"post" => 'uint',
			"form" => array_merge(array(
				"type" => "dynselect",
				"js_func_add" => "event_cal_select_add",
				"params" => 'size="5"'
			), kota_get_form("ko_event", "eventgruppen_id")),
		),  //eventgruppen_id
		"url" => array(
			"pre" => "",
			"form" => array(
				"type" => "text",
				"params" => 'size="60"',
			),
		),  //url
		"startdatum" => array(
			"list" => 'FCN:kota_listview_date',
			"pre" => "sql2datum('@VALUE@')",
			"post" => "sql_datum('@VALUE@')",
			"form" => array(
				"type" => "jsdate",
			),
		),  //startdatum
		"enddatum" => array(
			"pre" => "sql2datum('@VALUE@')",
			"post" => "sql_datum('@VALUE@')",
			"form" => array(
				"type" => "jsdate",
			),
		),  //enddatum
		"startzeit" => array(
			"list" => 'FCN:kota_listview_time',
			"pre" => "sql_zeit('@VALUE@')",
			"post" => "sql_zeit('@VALUE@')",
			"form" => array(
				"type" => "text",
				"params" => 'size="11" maxlength="11"',
			),
		),  //startzeit
		"endzeit" => array(
			"pre" => "sql_zeit('@VALUE@')",
			"post" => "sql_zeit('@VALUE@')",
			"form" => array(
				"type" => "text",
				"params" => 'size="11" maxlength="11"',
			),
		),  //endzeit
		"room" => array(
			"list" => "ko_html",
			"form" => array(
				"type" => "textplus",
				"params" => 'size="0"',
				"params_PLUS" => 'size="50" maxlength="50"',
			),
		),  //room
		"kommentar" => array(
			"list" => "ko_html",
			"pre" => "ko_html",
			"form" => array(
				"type" => "textarea",
				"params" => 'cols="50" rows="4"',
			),
		),  //kommentar
		"kommentar2" => array(
			"list" => "ko_html",
			"pre" => "ko_html",
			"form" => array(
				"type" => "textarea",
				"params" => 'cols="50" rows="4"',
			),
		),  //kommentar2
	);

	if(ko_module_installed('dp')) {
		$KOTA['ko_event']['dp']['form'] = array('type' => 'checkbox');
		$KOTA['ko_event']['dp']['list'] = 'FCN:kota_listview_boolyesno';
		$KOTA['ko_event']['_listview'][60] = array('name' => 'dp', 'sort' => 'dp');
	}

	if(ko_module_installed('reservation')) {
		$KOTA['ko_event']['reservationen']['list'] = 'FCN:kota_listview_event_reservations';
		$KOTA['ko_event']['_listview'][70] = array('name' => 'reservationen', 'sort' => FALSE, 'multiedit' => FALSE);
	}
}



if(in_array('ko_eventgruppen', $KOTA_TABLES)) {
	$KOTA['ko_eventgruppen'] = array(
		'_access' => array(
			'module' => 'daten',
			'chk_col' => 'id',
		),
		"_multititle" => array(
			"name" => "",
		),
		"_listview" => array(
			10 => array("name" => "name", "sort" => "name", "multiedit" => "name,shortname"),
			15 => array("name" => "calendar_id", "sort" => "calendar_id"),
			//20 => array("name" => "room", "sort" => "room"),
			//30 => array("name" => "startzeit", "sort" => "startzeit", "multiedit" => "startzeit,endzeit"),
			40 => array("name" => "kommentar", "sort" => "kommentar"),
			//50, 60, 70 are reserved for rota, tapes, res_combined (see below)
			80 => array("name" => "moderation", "sort" => "moderation"),
		),
		"calendar_id" => array(
			"post" => 'uint',
			"list" => 'db_get_column("ko_event_calendar", @VALUE@, "name")',
			"form" => array_merge(array(
				"type" => "textplus",
				"params_PLUS" => 'size="60" maxlength="200"',
			), kota_get_form("ko_eventgruppen", "calendar_id")),
		),  //gruppen_id
		"name" => array(
			"list" => "stripslashes('@VALUE@')",
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="100"'
			),
		),  //name
		"url" => array(
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="255"'
			),
		),  //url
		"shortname" => array(
			"list" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="10" maxlength="5"'
			),
		),  //shortname
		"moderation" => array(
			"pre" => "ko_html",
			"post" => 'uint',
			"list" => "FCN:kota_listview_ll",
			"form" => array_merge(array(
				"type" => "select",
				"params" => 'size="0"',
			), kota_get_form("ko_eventgruppen", "moderation")),
		),  //moderation
		"room" => array(
			"list" => "ko_html",
			"form" => array(
				"type" => "textplus",
				"params" => 'size="0"',
				"params_PLUS" => 'size="50" maxlength="50"',
				"descimg" => "bullet_star.png",
			),
		),  //room
		"startzeit" => array(
			"list" => 'FCN:kota_listview_time',
			"pre" => "sql_zeit('@VALUE@')",
			"post" => "sql_zeit('@VALUE@')",
			"form" => array(
				"type" => "text",
				"params" => 'size="11" maxlength="11"',
				"descimg" => "bullet_star.png",
			),
		),  //startzeit
		"endzeit" => array(
			"pre" => "sql_zeit('@VALUE@')",
			"post" => "sql_zeit('@VALUE@')",
			"form" => array(
				"type" => "text",
				"params" => 'size="11" maxlength="11"',
				"descimg" => "bullet_star.png",
			),
		),  //endzeit
		"kommentar" => array(
			"list" => "ko_html",
			"form" => array(
				"type" => "textarea",
				"params" => 'cols="50" rows="4"',
				"descimg" => "bullet_star.png",
			),
		),  //kommentar
		"farbe" => array(
			"post" => 'str_replace("#", "", format_userinput("@VALUE@", "alphanum"))',
			"form" => array(
				"type" => "color",
				"params" => 'size="10" maxlength="7"',
			),
		),  //farbe
	);

	if(ko_module_installed('dp')) {
		$KOTA['ko_eventgruppen']['dp']['form'] = array('type' => 'checkbox', 'descimg' => 'bullet_star.png');
		$KOTA['ko_eventgruppen']['_listview'][50] = array('name' => 'dp', 'sort' => 'dp');
		$KOTA['ko_eventgruppen']['dp']['list'] = 'FCN:kota_listview_boolyesno';
	}//if(ko_module_installed(dp))

	if(ko_module_installed('tapes')) {
		$KOTA['ko_eventgruppen']['tapes']['form'] = array('type' => 'checkbox');
		$KOTA['ko_eventgruppen']['_listview'][60] = array('name' => 'tapes', 'sort' => 'tapes');
		$KOTA['ko_eventgruppen']['tapes']['list'] = 'FCN:kota_listview_boolyesno';
	}//if(ko_module_installed(tapes))

	if(ko_module_installed('reservation') && $ko_menu_akt == 'daten') {
		kota_ko_reservation_item_id_dynselect($res_values, $res_output, 2);
		$KOTA['ko_eventgruppen']['resitems'] = array(
			'post' => 'intlist',
			'form' => array( 'type' => 'dyndoubleselect',
											 'js_func_add' => 'resgroup_doubleselect_add',
											 'values' => $res_values,
											 'descs' => $res_output,
											 'params' => 'size="7"',
											 'descimg' => 'bullet_star.png',)
		);
		$KOTA['ko_eventgruppen']['res_combined'] = array(
			'post' => 'uint',
			'form' => array('type' => 'checkbox')
		);
		$KOTA['ko_eventgruppen']['res_startzeit'] = array(
			'pre' => "sql_zeit('@VALUE@')",
			'post' => "sql_zeit('@VALUE@')",
			'form' => array('type' => 'text',
											'params' => 'size="11" maxlength="11"',
											),
		);
		$KOTA['ko_eventgruppen']['res_endzeit'] = array(
			'pre' => "sql_zeit('@VALUE@')",
			'post' => "sql_zeit('@VALUE@')",
			'form' => array('type' => 'text',
											'params' => 'size="11" maxlength="11"',
											),
		);
		$KOTA['ko_eventgruppen']['_listview'][70] = array('name' => 'res_combined', 'sort' => 'res_combined');
		$KOTA['ko_eventgruppen']['res_combined']['list'] = 'FCN:kota_listview_boolyesno';
	}//if(ko_module_installed(reservation))

	if(ko_module_installed('groups')) {
		//Add group select to event group (notify)
		$KOTA['ko_eventgruppen']['notify'] = array('post' => 'format_userinput("@VALUE@", "alphanumlist")',
																							 'form' => array_merge(array(
																								'type' => 'doubleselect',
																								'params' => 'size="7"',
																							), kota_get_form('ko_eventgruppen', 'notify')),
																							);
	}//if(ko_module_installed(groups))

}


if(in_array('ko_dp_dienste', $KOTA_TABLES)) {
	$KOTA['ko_dp_dienste'] = array(
		'_access' => array(
			'module' => 'dp',
			'chk_col' => 'id',
		),
		"_multititle" => array(
			"name" => "",
		),
		"_listview" => array(
			10 => array("name" => "name"),
			20 => array("name" => "_leader", "multiedit" => FALSE),
			30 => array("name" => "_status", "multiedit" => FALSE),
		),
		"name" => array(
			"list" => 'ko_html',
			"post" => 'js',
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="100"'
			),
		),  //name
		"maxleute" => array(
			"post" => 'uint',
			"form" => array(
				"type" => "text",
				"params" => 'size="4" maxlength="2"',
			),
		),  //maxleute
		"tg" => array(
			"post" => 'intlist',
			"form" => array_merge(array(
				"type" => "doubleselect",
				"params" => 'size="7"',
			), kota_get_form("ko_dp_dienste", "tg")),
		),  //tg
	);

	if(ko_module_installed('groups')) {
		//Add group select to dp form
		$KOTA['ko_dp_dienste']['groupid'] = array('post' => 'format_userinput("@VALUE@", "group_role")',
																							'form' => array_merge(array(
																								'type' => 'doubleselect',
																								'params' => 'size="7"',
																							), kota_get_form('ko_dp_dienste', 'groupid')),
																							);
	}
}


if(in_array('ko_dp_superdienste', $KOTA_TABLES)) {
	$KOTA['ko_dp_superdienste'] = array(
		"_multititle" => array(
			"name" => "",
		),
		"_listview" => array(
			10 => array("name" => "name", "multiedit" => FALSE),
			20 => array("name" => "dienste", "multiedit" => FALSE),
		),
		"name" => array(
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="100"'
			),
		),  //name
		"dienste" => array(
			"list" => 'ko_html(ko_dienstliste("@VALUE@"))',
			"post" => 'intlist',
			"form" => array_merge(array(
				"type" => "doubleselect",
				"params" => 'size="7"',
			), kota_get_form("ko_dp_superdienste", "dienste")),
		),  //dienste
	);
}



if(in_array('ko_donations', $KOTA_TABLES)) {
	$KOTA['ko_donations'] = array(
		'_access' => array(
			'module' => 'donations',
			'chk_col' => 'account',
		),
		"_multititle" => array(
			"date" => "strftime('".$GLOBALS["DATETIME"]["dmY"]."', sql2timestamp('@VALUE@'))",
			"person" => "ko_get_person_name(@VALUE@)",
		),
		"_listview" => array(
			10 => array("name" => "date", "sort" => "date"),
			20 => array("name" => "account", "sort" => "account"),
			30 => array("name" => "amount", "sort" => "amount"),
			40 => array("name" => "person", "sort" => "person"),
			50 => array("name" => "source", "sort" => "source"),
			60 => array("name" => "comment", "sort" => "comment"),
		),
		"date" => array(
			"list" => "strftime('".$GLOBALS["DATETIME"]["dmY"]."', sql2timestamp('@VALUE@'))",
			"pre" => "sql2datum('@VALUE@')",
			"post" => "sql_datum('@VALUE@')",
			"form" => array(
				"type" => "jsdate",
				'prefill_new' => TRUE,
			),
		),  //date
		"source" => array(
			"form" => array(
				"type" => "textplus",
				"params" => 'size="40" maxlength="100"',
			),
		),  //source
		"account" => array(
			"list" => 'db_get_column("ko_donations_accounts", @VALUE@, "number,name", " ")',
			"post" => 'uint',
			"form" => array_merge(array(
				"type" => "select",
				"params" => 'size="0"'
			), kota_get_form("ko_donations", "account")),
		),  //account
		"amount" => array(
			"post" => 'float',
			"form" => array(
				"type" => "text",
				"params" => 'size="10" maxlength="40"'
			),
		),  //amount
		"person" => array(
			"list" => 'FCN:kota_listview_people',
			"post" => 'uint',
			"form" => array(
				"type" => "peopleselect",
				"params" => 'size="7" style="width:150px;"'
			),
		),  //person
		"comment" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "textarea",
				"params" => 'cols="40" rows="5"',
			),
		),  //comment
		"reoccuring" => array(
			"pre" => "ko_html",
			"post" => 'uint',
			"form" => array_merge(array(
				"type" => "select",
				"params" => 'size="0"',
			), kota_get_form("ko_donations", "reoccuring")),
		),  //reoccuring
	);
}


if(in_array('ko_donations_accounts', $KOTA_TABLES)) {
	$KOTA['ko_donations_accounts'] = array(
		'_access' => array(
			'module' => 'donations',
			'chk_col' => 'id',
		),
		"_multititle" => array(
			"number" => "",
			"name" => "",
		),
		"_listview" => array(
			10 => array("name" => "number"),
			20 => array("name" => "name"),
			30 => array("name" => "comment"),
		),
		"number" => array(
			"form" => array(
				"type" => "text",
				"params" => 'size="60"',
			),
		),  //number
		"name" => array(
			"form" => array(
				"type" => "text",
				"params" => 'size="60"',
			),
		),  //name
		"comment" => array(
			"form" => array(
				"type" => "textarea",
				"params" => 'cols="40" rows="3"',
			),
		),  //comment
	);
}


if(in_array('ko_leute', $KOTA_TABLES)) {
	$KOTA['ko_leute'] = array(
		'_access' => array(
			'module' => 'leute',
			'chk_col' => 'ALL&id',
		),
		"_multititle" => array(
			"vorname" => "",
			"nachname" => "",
		),
		"anrede" => array(
			"form" => array(
				"type" => "select",
				"params" => 'size="0"',
				"values" => array_merge(array(""), db_get_enums("ko_leute", "anrede")),
				"descs" => array_merge(array(""), db_get_enums("ko_leute", "anrede")),
			),
		),  //anrede
		"firm" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="50" maxlength="200"',
			),
		),  //firm
		"department" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="50" maxlength="200"',
			),
		),  //department
		"vorname" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="50" maxlength="50"',
			),
		),  //vorname
		"nachname" => array(
			"pre" => "ko_html",
			"post" => (in_array("nachname", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "FCN:ko_multiedit_familie" : ""),
			"form" => array(
				"descimg" => (in_array("nachname", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "icon_familie.png" : ""),
				"type" => "text",
				"params" => 'size="50" maxlength="50"',
			),
		),  //nachname
		"adresse" => array(
			"pre" => "ko_html",
			"post" => (in_array("adresse", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "FCN:ko_multiedit_familie" : ""),
			"form" => array(
				"descimg" => (in_array("adresse", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "icon_familie.png" : ""),
				"type" => "text",
				"params" => 'size="60" maxlength="100"',
			),
		),  //adresse
		"adresse_zusatz" => array(
			"pre" => "ko_html",
			"post" => (in_array("adresse_zusatz", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "FCN:ko_multiedit_familie" : ""),
			"form" => array(
				"descimg" => (in_array("adresse_zusatz", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "icon_familie.png" : ""),
				"type" => "text",
				"params" => 'size="60" maxlength="100"',
			),
		),  //adresse_zusatz
		"plz" => array(
			"pre" => "ko_html",
			"post" => (in_array("plz", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "FCN:ko_multiedit_familie" : ""),
			"form" => array(
				"descimg" => (in_array("plz", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "icon_familie.png" : ""),
				"type" => "text",
				"params" => 'size="11" maxlength="11"',
			),
		),  //plz
		"ort" => array(
			"pre" => "ko_html",
			"post" => (in_array("ort", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "FCN:ko_multiedit_familie" : ""),
			"form" => array(
				"descimg" => (in_array("ort", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "icon_familie.png" : ""),
				"type" => "text",
				"params" => 'size="50" maxlength="50"',
			),
		),  //ort
		"land" => array(
			"pre" => "ko_html",
			"post" => (in_array("land", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "FCN:ko_multiedit_familie" : ""),
			"form" => array_merge(array(
				"descimg" => (in_array("land", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "icon_familie.png" : ""),
				"type" => "textplus",
				"params" => 'size="0"',
				"params_PLUS" => 'size="50" maxlength="50"',
			), kota_get_form("ko_leute", "land")),
		),  //land
		"telp" => array(
			"pre" => "ko_html",
			"post" => (in_array("telp", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "FCN:ko_multiedit_familie" : ""),
			"form" => array(
				"descimg" => (in_array("telp", $GLOBALS['COLS_LEUTE_UND_FAMILIE']) ? "icon_familie.png" : ""),
				"type" => "text",
				"params" => 'size="30" maxlength="30"',
			),
		),  //telp
		"telg" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="30" maxlength="30"',
			),
		),  //telg
		"natel" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="30" maxlength="30"',
			),
		),  //natel
		"fax" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="30" maxlength="30"',
			),
		),  //fax
		"email" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="100" maxlength="100"',
			),
		),  //email
		"web" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="50" maxlength="50"',
			),
		),  //web
		"geburtsdatum" => array(
			"pre" => "sql2datum('@VALUE@')",
			"post" => "sql_datum('@VALUE@')",
			"form" => array(
				"type" => "text",
				"params" => 'size="11" maxlength="11"',
			),
		),  //geburtsdatum
		"zivilstand" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "select",
				"params" => 'size="0"',
				"values" => db_get_enums("ko_leute", "zivilstand"),
				"descs" => db_get_enums_ll("ko_leute", "zivilstand"),
			),
		),  //zivilstand
		"geschlecht" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "select",
				"params" => 'size="0"',
				"values" => db_get_enums("ko_leute", "geschlecht"),
				"descs" => db_get_enums_ll("ko_leute", "geschlecht"),
			),
		),  //geschlecht
		"memo1" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "textarea",
				"params" => 'cols="50" rows="4"',
			),
		),  //memo1
		"memo2" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "textarea",
				"params" => 'cols="50" rows="4"',
			),
		),  //memo2
		"famfunction" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "select",
				"params" => 'size="0"',
				"values" => db_get_enums("ko_leute", "famfunction"),
				"descs" => db_get_enums_ll("ko_leute", "famfunction"),
			),
		),  //famfunction
		"picture" => array(
			"form" => array(
				"type" => "file",
				"params" => '',
			),
		),  //picture
	);

	if(ko_module_installed('kg')) {
		$KOTA['ko_leute']['smallgroups']['form'] = array_merge(array('type' => 'doubleselect', 'params' => 'size="7"',),
																			kota_get_form('ko_leute', 'smallgroups'));
	}

	if(ko_module_installed('groups')) {
		ko_get_access('groups');
		$z_where = "AND (`start` = '0000-00-00' OR `start` < NOW()) AND (`stop` = '0000-00-00' OR `stop` > NOW())";
		ko_get_groups($groups, $z_where);
		ko_get_grouproles($roles);
		foreach($groups as $group) {
			if(($access['groups']['ALL'] > 1 || $access['groups'][$group['id']] > 1) && $group['type'] != 1) {
				list($values, $descs) = ko_groups_get_group_id_names($group['id'], $groups, $roles);
				$KOTA['ko_leute']['MODULEgrp'.$group['id']] = array('form' => array('desc' => $group['name'],
																																						'type' => 'doubleselect',
																																						'params' => 'size="4"',
																																						'values' => $values,
																																						'descs' => $descs),
				);
				//Datafields for multiedit
				foreach(explode(',', $group['datafields']) as $df) {
					if(!$df) continue;
					//Only dummy definition, will be definied properly as html element in ko_multiedit_formular()
					$KOTA['ko_leute']['MODULEgdf'.$group['id'].$df] = array('form' => array('type' => 'html'));  //Only dummy definition
				}
			}
		}
	}

}


if(in_array('ko_kleingruppen', $KOTA_TABLES)) {
	$KOTA['ko_kleingruppen'] = array(
		'_access' => array(
			'module' => 'kg',
			'chk_col' => '',
		),
		"_multititle" => array(
			"name" => "",
		),
		"type" => array(
			"form" => array(
				"type" => "textplus",
				"params" => 'size="30" maxlength="100"',
				"select_case_sensitive" => TRUE,
			),
		),  //type
		"name" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="30" maxlength="100"',
			),
		),  //name
		"alter" => array(
			"pre" => "ko_html",
			"post" => 'int',
			"form" => array(
				"type" => "text",
				"params" => 'size="30" maxlength="20"',
			),
		),  //alter
		"geschlecht" => array(
			"form" => array(
				"type" => "select",
				"params" => 'size="0"',
				"values" => db_get_enums("ko_kleingruppen", "geschlecht"),
				"descs" => db_get_enums_ll("ko_kleingruppen", "geschlecht"),
			),
		),  //geschlecht
		"wochentag" => array(
			"form" => array(
				"type" => "select",
				"params" => 'size="0"',
				"values" => db_get_enums("ko_kleingruppen", "wochentag"),
				"descs" => db_get_enums_ll("ko_kleingruppen", "wochentag"),
			),
		),  //wochentag
		"ort" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="30" maxlength="100"',
			),
		),  //ort
		"zeit" => array(
			"form" => array(
				"type" => "text",
				"params" => 'size="30" maxlength="10"',
			),
		),  //zeit
		"treffen" => array(
			"form" => array(
				"type" => "select",
				"params" => 'size="0"',
				"values" => db_get_enums("ko_kleingruppen", "treffen"),
				"descs" => db_get_enums_ll("ko_kleingruppen", "treffen"),
			),
		),  //treffen
		"anz_frei" => array(
			"pre" => "ko_html",
			"post" => 'int',
			"form" => array(
				"type" => "text",
				"params" => 'size="4" maxlength="4"',
			),
		),  //anz_frei
		"kg-gen" => array(
			"pre" => "ko_html",
			"post" => 'int',
			"form" => array(
				"type" => "text",
				"params" => 'size="9" maxlength="9"',
			),
		),  //kg-gen
		"region" => array(
			"form" => array(
				"type" => "textplus",
				"params" => 'size="30" maxlength="100"',
			),
		),  //region
		"comments" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "textarea",
				"params" => 'cols="30" rows="4"',
			),
		),  //comments
		"picture" => array(
			'list' => 'FCN:kota_pic_tooltip',
			"form" => array(
				"type" => "file",
				"params" => '',
			),
		),  //picture
		"url" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="30"',
			),
		),  //url
		"eventGroupID" => array(
			"pre" => "ko_html",
			"post" => 'uint',
			"form" => array_merge(array(
				"type" => "select",
				"params" => 'size="0"',
			), kota_get_form("ko_kleingruppen", "eventGroupID")),
		),  //eventGroupID
	);

	if(ko_module_installed('mailing')) {
		$KOTA['ko_kleingruppen']['mailing_alias'] = array(
			'post' => 'FCN:kota_mailing_check_unique_alias',
			'list' => 'FCN:kota_mailing_link_alias',
			'form' => array(
				'type' => 'text',
				'params' => 'size="40"',
			),
		);
	}

}



if(in_array('ko_reservation', $KOTA_TABLES)) {
	$KOTA['ko_reservation'] = array(
		'_access' => array(
			'module' => 'reservation',
			'chk_col' => 'item_id',
		),
		"_multititle" => array(
			"item_id" => "ko_get_resitem_name('@VALUE@')",
			"startdatum" => "sql2datum('@VALUE@')",
			"zweck" => "",
		),
		"item_id" => array(
			"post" => 'intlist',
			"list" => "ko_get_resitem_name('@VALUE@')",
			"form" => array_merge(array(
				"type" => "dynselect",
				"js_func_add" => "resgroup_select_add",
				"params" => 'size="5"',
				"new_row" => TRUE,
				"colspan" => 'colspan="2"',
			), kota_get_form("ko_reservation", "item_id")),
		),  //item_id
		"startdatum" => array(
			"list" => 'FCN:kota_listview_date',
			"pre" => "sql2datum('@VALUE@')",
			"post" => "sql_datum('@VALUE@')",
			"form" => array(
				"type" => "jsdate",
			),
		),  //startdatum
		"enddatum" => array(
			"pre" => "sql2datum('@VALUE@')",
			"post" => "sql_datum('@VALUE@')",
			"form" => array(
				"type" => "jsdate",
			),
		),  //enddatum
		"startzeit" => array(
			"list" => 'FCN:kota_listview_time',
			"pre" => "sql_zeit('@VALUE@')",
			"post" => "sql_zeit('@VALUE@')",
			"form" => array(
				"type" => "text",
				"params" => 'size="11" maxlength="11"',
			),
		),  //startzeit
		"endzeit" => array(
			"pre" => "sql_zeit('@VALUE@')",
			"post" => "sql_zeit('@VALUE@')",
			"list" => "",
			"form" => array(
				"type" => "text",
				"params" => 'size="11" maxlength="11"',
			),
		),  //endzeit
		"zweck" => array(
			"pre" => 'ko_html',
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="255"',
			),
		),  //zweck
		"name" => array(
			"pre" => 'ko_html',
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="255"',
			),
		),  //name
		"email" => array(
			"pre" => 'ko_html',
			"post" => 'email',
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="255"',
			),
		),  //email
		"telefon" => array(
			"pre" => 'ko_html',
			"post" => 'alphanum++',
			"form" => array(
				"type" => "text",
				"params" => 'size="50" maxlength="255"',
			),
		),  //telefon
		"comments" => array(
			"pre" => 'ko_html',
			"form" => array(
				"type" => "textarea",
				"params" => 'rows="3" cols="50"',
			),
		),  //comments
	);
}



if(in_array('ko_resitem', $KOTA_TABLES)) {
	$KOTA['ko_resitem'] = array(
		'_access' => array(
			'module' => 'reservation',
			'chk_col' => 'id',
		),
		"_multititle" => array(
			"name" => "",
		),
		"gruppen_id" => array(
			"post" => 'uint',
			"form" => array_merge(array(
				"type" => "textplus",
				"params_PLUS" => 'size="60" maxlength="100"',
			), kota_get_form("ko_resitem", "gruppen_id")),
		),  //gruppen_id
		"name" => array(
			"pre" => "ko_html",
			"post" => 'js',
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="100"',
			),
		),  //name
		"bild" => array(
			"form" => array(
				"type" => "file",
				"params" => 'size="60"',
			),
		),  //name
		"beschreibung" => array(
			"pre" => 'str_replace("<br />", "\n", '."'@VALUE@'".')',
			"post" => 'htmlentities(format_userinput("@VALUE@", "text"))',
			"form" => array(
				"type" => "textarea",
				"params" => 'cols="60" rows="5"',
			),
		),  //beschreibung
		"linked_items" => array(
			"post" => 'intlist',
			"form" => array(
				"type" => "dyndoubleselect",
				"js_func_add" => "resgroup_doubleselect_add",
				"params" => 'size="7"',
			),
		),  //linked_items
		"farbe" => array(
			"post" => 'str_replace("#", "", format_userinput("@VALUE@", "alphanum"))',
			"form" => array(
				"type" => "color",
				"params" => 'size="10" maxlength="7"',
			),
		),  //farbe
		"moderation" => array(
			"pre" => "ko_html",
			"post" => 'uint',
			"form" => array_merge(array(
				"type" => "select",
				"params" => 'size="0"',
			), kota_get_form("ko_resitem", "moderation")),
		),  //moderation
	);
}



if(in_array('ko_groups', $KOTA_TABLES)) {
	$KOTA['ko_groups'] = array(
		'_access' => array(
			'module' => 'groups',
			'chk_col' => 'ALL&id',
		),
		"_multititle" => array(
			"name" => "",
		),
		"name" => array(
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="200"'
			),
		),  //name
		"description" => array(
			"form" => array(
				"type" => "textarea",
				"params" => 'cols="50" rows="4"',
			),
		),  //description
		"start" => array(
			"pre" => "sql2datum('@VALUE@')",
			"post" => "sql_datum('@VALUE@')",
			"form" => array(
				"type" => "jsdate",
			),
		),  //start
		"stop" => array(
			"pre" => "sql2datum('@VALUE@')",
			"post" => "sql_datum('@VALUE@')",
			"form" => array(
				"type" => "jsdate",
			),
		),  //stop
		"roles" => array(
			"form" => array_merge(array(
				"type" => "doubleselect",
				"params" => 'size="4"',
			), kota_get_form("ko_groups", "roles")),
		),  //roles
		"type" => array(
			"form" => array(
				"type" => "checkbox",
			),
		),  //type
	);
}




if(in_array('ko_tapes', $KOTA_TABLES)) {
	$KOTA['ko_tapes'] = array(
		'_access' => array(
			'module' => 'tapes',
			'chk_col' => 'group_id',
		),
		"_multititle" => array(
			"date" => "sql2datum('@VALUE@')",
			"title" => "",
		),
		"group_id" => array(
			"post" => "uint",
			"form" => array_merge(array(
				"type" => "select",
				"params" => 'size="0"'
			), kota_get_form("ko_tapes", "group_id")),
		),  //group_id
		"date" => array(
			"pre" => "sql2datum('@VALUE@')",
			"post" => "sql_datum('@VALUE@')",
			"form" => array(
				"type" => "jsdate",
			),
		),  //date
		"serie_id" => array(
			"post" => "FCN:ko_multiedit_tapeserie",
			"form" => array_merge(array(
				"type" => "textplus",
				"params" => 'size="0"',
				"params_PLUS" => 'size="60" maxlength="255"',
			), kota_get_form("ko_tapes", "serie_id")),
		),  //serie_id
		"title" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="255"',
			),
		),  //title
		"subtitle" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="255"',
			),
		),  //subtitle
		"preacher" => array(
			"pre" => "ko_html",
			"form" => array_merge(array(
				"type" => "textplus",
				"params" => 'size="0"',
				"params_PLUS" => 'size="60" maxlength="255"',
			), db_select_distinct("ko_tapes", "preacher", "", "", TRUE)),
		),  //preacher
		"item_number" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="200"',
			),
		),  //item_number
		"price" => array(
			"form" => array(
				"type" => "text",
				"params" => 'size="10" maxlength="20"',
			),
		),  //item_number
	);
}



	/* Tape groups */

if(in_array('ko_tapes_groups', $KOTA_TABLES)) {
	$KOTA['ko_tapes_groups'] = array(
		'_access' => array(
			'module' => 'tapes',
			'chk_col' => 'id',
		),
		"_multititle" => array(
			"name" => "",
		),
		"name" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="255"',
			),
		),  //name
		"printname" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="255"',
			),
		),  //printname
	);
}



if(in_array('ko_tapes_series', $KOTA_TABLES)) {
	$KOTA['ko_tapes_series'] = array(
		"_multititle" => array(
			"name" => "",
		),
		"name" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="255"',
			),
		),  //name
		"printname" => array(
			"pre" => "ko_html",
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="255"',
			),
		),  //printname
	);
}



if(in_array('ko_pdf_layout', $KOTA_TABLES)) {
	$KOTA['ko_pdf_layout'] = array(
		"_listview" => array(
			10 => array("name" => "name"),
		),
		"name" => array(
			"post" => 'js',
			"form" => array(
				"type" => "text",
				"params" => 'size="60" maxlength="100"'
			),
		),  //name
	);
}


if(in_array('ko_tracking', $KOTA_TABLES)) {
	$KOTA['ko_tracking'] = array(
		'_access' => array(
			'module' => 'tracking',
			'chk_col' => 'id',
		),
		'_multititle' => array(
			'name' => '',
		),
		'_listview' => array(
			10 => array('name' => 'name', 'sort' => 'name', 'multiedit' => 'name'),
			20 => array('name' => 'group_id', 'sort' => 'group_id', 'multiedit' => 'group_id'),
			30 => array('name' => 'mode', 'sort' => 'mode', 'multiedit' => 'mode'),
			40 => array('name' => 'date_mode', 'sort' => 'date_mode', 'multiedit' => ''),
		),
		'group_id' => array(
			"post" => "FCN:ko_multiedit_tracking_group",
			'list' => 'db_get_column("ko_tracking_groups", @VALUE@, "name")',
			'form' => array_merge(array(
				'type' => 'textplus',
				'params_PLUS' => 'size="60" maxlength="200"',
			), kota_get_form('ko_tracking', 'group_id')),
		),  //group_id
		'name' => array(
			'pre' => 'ko_html',
			'form' => array(
				'type' => 'text',
				'params' => 'size="60" maxlength="200"',
				'new_row' => TRUE,
			),
		),
		'mode' => array(
			"list" => "FCN:kota_listview_ll",
			'form' => array(
				'type' => 'select',
				'values' => array('simple', 'value', 'valueNonNum', 'type'),
				'descs' => array(getLL('kota_ko_tracking_mode_simple'), getLL('kota_ko_tracking_mode_value'), getLL('kota_ko_tracking_mode_valueNonNum'), getLL('kota_ko_tracking_mode_type')),
			),
		),
		'filter' => array(
			'form' => array_merge(array(
				'type' => 'select',
			), kota_get_form('ko_tracking', 'filter')),
		),
		'label_value' => array(
			'pre' => 'ko_html',
			'form' => array(
				'type' => 'text',
				'params' => 'size="60" maxlength="200"',
			),
		),
		'types' => array(
			'form' => array(
				'type' => 'textarea',
				'params' => 'cols="50" rows="4"',
			),
		),
		'date_mode' => array(
			"list" => "FCN:kota_listview_ll",
			'form' => array(
				'type' => 'select',
				'values' => array('eventgroup', 'dates', 'weekdays'),
				'descs' => array(getLL('kota_ko_tracking_date_mode_eventgroup'), getLL('kota_ko_tracking_date_mode_dates'), getLL('kota_ko_tracking_date_mode_weekdays')),
			),
		),
		'date_eventgroup' => array(
			'form' => array_merge(array(
				'type' => 'select',
			), kota_get_form('ko_tracking', 'date_eventgroup')),
		),
		'dates' => array(
			'post' => 'FCN:kota_sort_comma_list',
			'form' => array(
				'type' => 'multidateselect',
				'params' => 'size="7"',
			),
		),
		'date_weekdays' => array(
			'form' => array_merge(array(
				'type' => 'doubleselect',
				'params' => 'size="7"',
			), kota_get_form('ko_tracking', 'date_weekdays')),
		),
		'description' => array(
			'form' => array(
				'type' => 'textarea',
				'params' => 'cols="50" rows="4"',
			),
		),

	);
}



if(in_array('ko_news', $KOTA_TABLES)) {
	$KOTA['ko_news'] = array(
		'_multititle' => array(
			'title' => '',
		),
		'_listview' => array(
			10 => array('name' => 'title', 'sort' => 'title', 'multiedit' => 'title'),
			20 => array('name' => 'type', 'sort' => 'type', 'multiedit' => 'type'),
			30 => array('name' => 'cdate', 'sort' => 'cdate', 'multiedit' => 'cdate'),
		),
		'type' => array(
			'list' => 'FCN:kota_listview_ll',
			'form' => array(
				'type' => 'select',
				'values' => array('1', '2'),
				'descs' => array(getLL('kota_ko_news_type_1'), getLL('kota_ko_news_type_2')),
			),
		),
		'title' => array(
			'pre' => 'ko_html',
			'form' => array(
				'type' => 'text',
				'params' => 'size="60" maxlength="255"',
			),
		),
		'subtitle' => array(
			'pre' => 'ko_html',
			'form' => array(
				'type' => 'text',
				'params' => 'size="60" maxlength="255"',
			),
		),
		'text' => array(
			'pre' => 'ko_html',
			'form' => array(
				'type' => 'textarea',
				'params' => 'cols="50" rows="8"',
			),
		),
		'link' => array(
			'pre' => 'ko_html',
			'form' => array(
				'type' => 'text',
				'params' => 'size="60" maxlength="255"',
			),
		),
		'author' => array(
			'pre' => 'ko_html',
			'form' => array(
				'type' => 'text',
				'params' => 'size="60" maxlength="255"',
			),
		),
		'cdate' => array(
			'list' => "sql2datum('@VALUE@')",
			'pre' => "sql2datum('@VALUE@')",
			'post' => "sql_datum('@VALUE@')",
			'form' => array(
				'type' => 'jsdate',
			),
		),
	);
}



if(in_array('_ko_sms_log', $KOTA_TABLES)) {
	$KOTA['_ko_sms_log'] = array(
		"_listview" => array(
			10 => array('name' => 'date'),
			20 => array('name' => 'user_id'),
			30 => array('name' => 'credits'),
			40 => array('name' => 'ratio'),
			50 => array('name' => 'numbers'),
			60 => array('name' => 'text'),
		),
		'date' => array(),
		'user_id' => array(),
		'credits' => array(),
		'ratio' => array(),
		'numbers' => array(),
		'text' => array(),
	);
}


//Add definition for ko_reservation_mod only used for multiedit of open reservations
if(in_array('ko_reservation', $KOTA_TABLES)) $KOTA["ko_reservation_mod"] = $KOTA["ko_reservation"];


//Only show kommentar2 for events to logged in users
if(in_array('ko_event', $KOTA_TABLES) && $_SESSION['ses_userid'] != ko_get_guest_id()) {
	$KOTA['ko_event']['_listview']['35'] = array('name' => 'kommentar2', 'sort' => 'kommentar2');
}

//KOTA for ko_event_mod as a copy from ko_event
if(in_array('ko_event', $KOTA_TABLES)) {
	$KOTA["ko_event_mod"] = $KOTA["ko_event"];
	$KOTA["ko_event_mod"]["_listview"][70] = array("name" => "_user_id", "sort" => "_user_id");
	$KOTA["ko_event_mod"]["_user_id"] = array("list" => "FCN:kota_listview_login");
}



//Include kota.inc from web directory (specific to each installation)
if(file_exists($BASE_PATH."config/kota.inc")) {
	include($BASE_PATH."config/kota.inc");
}

//Allow plugins to change KOTA
foreach($GLOBALS['PLUGINS'] as $plugin) {
	$file = $BASE_PATH."plugins/".$plugin["name"]."/kota.inc";
	if(file_exists($file)) include($file);
}




//Order listview arrays by index, so loops over them will be in the right order
foreach($KOTA as $table => $table_data) {
	if(!isset($table_data["_listview"])) continue;
	ksort($KOTA[$table]["_listview"]);
}



/**
  * Liefert Select-Werte fr einzelne Tabelle-Spalten
	*/
function kota_get_form($table, $column) {
	global $access;
	global $all_groups;
	global $SMALLGROUPS_ROLES;

	$data = array();

	switch($table) {
		case "ko_dp_dienste":
			switch($column) {
				case "tg":
					ko_get_eventgruppen($grps, '', "AND `type` = '0'");
					foreach($grps as $grp) {
						$data["values"][] = $grp["id"];
						$data["descs"][] = $grp["name"];
					}
				break;  //tg

				case "groupid":
					$groups = ko_groups_get_recursive(ko_get_groups_zwhere(), TRUE);
					if(!is_array($all_groups)) ko_get_groups($all_groups);
					ko_get_access('groups');
					ko_get_grouproles($roles);
					$add_roles = ko_get_setting('dp_showroles') == 1;
					foreach($groups as $grp) {
						if($access['groups']['ALL'] < 1 && $access['groups'][$grp['id']] < 1) continue;
						//Hierarchie darstellen
						$pre = "";
						$mother_line = ko_groups_get_motherline($grp["id"], $all_groups);
						$depth = sizeof($mother_line);
						for($i=0; $i<$depth; $i++) $pre .= "&nbsp;&nbsp;";
						$data["values"][] = "g".$grp["id"];
						$data["descs"][] = $pre.ko_html($grp["name"]);
						//Add roles
						if($add_roles && $grp['roles'] != '') {
							foreach(explode(',', $grp['roles']) as $rid) {
								$data['values'][] = 'g'.$grp['id'].':r'.$rid;
								$data['descs'][] = $pre.ko_html($grp['name'].': '.$roles[$rid]['name']);
							}
						}
					}
				break;  //groupid
			}  //switch(column)
		break;  //ko_dp_dienste

		case "ko_dp_superdienste":
			switch($column) {
				case "dienste":
					ko_get_dienste($dienste);
					foreach($dienste as $dienst) {
						$data["values"][] = $dienst["id"];
						$data["descs"][] = $dienst["name"];
					}
				break;  //dienste
			}  //switch(column)
		break;  //ko_dp_superdienste

		case "ko_event":
			switch($column) {
				case "eventgruppen_id":
					kota_ko_event_eventgruppen_id_dynselect($data["values"], $data["descs"], 2);
				break; //eventgruppen_id
			}  //switch(column)
		break;  //ko_event

		case "ko_eventgruppen":
			switch($column) {
				case "calendar_id":
					ko_get_event_calendar($cals);
					//Add empty entry
					$data["values"][] = "";
					$data["descs"][] = "";
					foreach($cals as $id => $cal) {
						if($access['daten']['cal'.$id] > 2) {
							$data["values"][] = $id;
							$data["descs"][] = $cal["name"];
						}
					}
				break;  //calendar_id
				case "moderation":
					$data["values"] = array(0, 1, 2);
					$data["descs"] = array(getLL("res_mod_no"), getLL("res_mod_yes"), getLL("res_mod_yes_mail"));
				break;  //moderation
				case "notify":
					$groups = ko_groups_get_recursive(ko_get_groups_zwhere());
					if(!is_array($all_groups)) ko_get_groups($all_groups);
					ko_get_access('groups');
					foreach($groups as $grp) {
						if($access['groups']['ALL'] < 1 && $access['groups'][$grp['id']] < 1) continue;
						//Hierarchie darstellen
						$pre = "";
						$mother_line = ko_groups_get_motherline($grp["id"], $all_groups);
						$depth = sizeof($mother_line);
						for($i=0; $i<$depth; $i++) $pre .= "&nbsp;&nbsp;";
						$data["values"][] = "g".$grp["id"];
						$data["descs"][] = $pre.ko_html($grp["name"]);
					}
				break;  //notify
			}//switch(column)
		break; //ko_eventgruppen

		case "ko_leute":
			switch($column) {
				case "land":
					$data["values"][] = $data["descs"][] = "";
					ko_get_all_countries($c);
					$data["values"] = $data["descs"] = $c;
				break;  //land
				case 'smallgroups':
					$kgs = db_select_data('ko_kleingruppen', 'WHERE 1=1', '*', 'ORDER BY name ASC');
					foreach($kgs as $kg) {
						foreach($SMALLGROUPS_ROLES as $role) {
							$data['values'][] = $kg['id'].':'.$role;
							$data['descs'][] = ko_html($kg['name'].': '.getLL('kg_roles_'.$role));
						}
					}
					return $data;
				break;
			}  //switch(column)
		break;  //ko_leute


		case "ko_kleingruppen":
			switch($column) {
				case "eventGroupID":
					$data["values"][] = $data["descs"][] = "";
					ko_get_eventgruppen($grps, '', "AND `type` = '0'");
					foreach($grps as $grp) {
						$data["values"][] = $grp["id"];
						$data["descs"][] = $grp["name"];
					}
				break;  //eventGroupID
			}  //switch(column)
		break;  //ko_kleingruppen


		case "ko_reservation":
			switch($column) {
				case "item_id":
					kota_ko_reservation_item_id_dynselect($data["values"], $data["descs"], 2);
				break; //item_id

			}//switch(columns)
		break;  //ko_reservation


		case "ko_resitem":
			switch($column) {
				case "gruppen_id":
					ko_get_resgroups($gruppen);
					foreach($gruppen as $i => $g) {
						if($access['reservation']['grp'.$i] < 4) continue;
						$data["values"][] = $i;
						$data["descs"][] = $g["name"];
					}
				break;  //gruppen_id
				case "moderation":
					$data["values"] = array(0, 1, 2);
					$data["descs"] = array(getLL("res_mod_no"), getLL("res_mod_yes"), getLL("res_mod_yes_mail"));
				break;  //moderation
			}//switch column
		break;  //ko_resitem

	
		case "ko_tapes":
			switch($column) {
				case "group_id":
					ko_get_tapegroups($gruppen);
					foreach($gruppen as $i => $g) {
						if($access['tapes']['ALL'] > 2 || $access['tapes'][$i] > 2) {
							$data["values"][] = $i;
							$data["descs"][] = $g["name"];
						}
					}
				break;  //group_id
				case "serie_id":
					ko_get_tapeseries($series);
					if(sizeof($series) > 0) {
						$data["values"][] = "";
						$data["descs"][] = "";
						foreach($series as $s) {
							if(!$s["name"]) continue;
							$data["values"][] = $s["id"];
							$data["descs"][] = $s["name"];
						}
					} else {
						$data["values"] = $data["descs"] = array("");
					}
				break;  //serie_id
			}//switch(columns)
		break;  //ko_tapes


		case "ko_groups":
			switch($column) {
				case "roles":
					ko_get_grouproles($roles);
					foreach($roles as $role) {
						$data["values"][] = $role["id"];
						$data["descs"][] = ko_html($role["name"]);
					}
					return $data;
				break;  //roles
			}//switch(column)
		break;  //ko_groups


		case "ko_donations":
			switch($column) {
				case "account":
					$accounts = db_select_data("ko_donations_accounts", "", "*", "ORDER BY number ASC");
					foreach($accounts as $i => $g) {
						if($access['donations']['ALL'] > 1 || $access['donations'][$i] > 1) {
							$data["values"][] = $i;
							$data["descs"][] = $g["number"]." ".$g["name"];
						}
					}
				break; //account

				case "reoccuring":
					$options = array(0, 7, 14, 30, 60, 182, 365);
					foreach($options as $g) {
						$data["values"][] = $g;
						$data["descs"][] = getLL("kota_ko_donations_reoccuring_".$g);
					}
				break; //reoccuring
			}  //switch(column)
		break;  //ko_donations


		case 'ko_tracking':
			switch($column) {
				case 'group_id':
					$groups = db_select_data('ko_tracking_groups', '', '*');
					//Add empty entry
					$data['values'][] = '';
					$data['descs'][] = '';
					foreach($groups as $id => $group) {
						$data['values'][] = $id;
						$data['descs'][] = $group['name'];
					}
				break;  //group_id

				case 'filter':
					$data['values'][] = $data['descs'][] = '';

					//Filter presets
					if(ko_module_installed('leute')) {
						$data['values'][] = '';
						$data['descs'][] = '--- '.strtoupper(getLL('submenu_leute_title_filter')).' ---';
						$filterset = array_merge((array)ko_get_userpref('-1', '', 'filterset', 'ORDER BY `key` ASC'), (array)ko_get_userpref($_SESSION['ses_userid'], '', 'filterset', 'ORDER BY `key` ASC'));

						foreach($filterset as $f) {
							$this_filter = unserialize($f['value']);
							$global_tag = $f['user_id'] == '-1' ? getLL('leute_filter_global_short') : '';
							$data['values'][] = $f['value'];
							$data['descs'][] = $global_tag.' '.$f['key'].($this_filter['cols'] ? ' +' : '');
						}
					}
					//Get small groups
					if(ko_module_installed('kg')) {
						$data['values'][] = '';
						$data['descs'][] = '--- '.strtoupper(getLL('kg_list_title')).' ---';
						$kgs = db_select_data('ko_kleingruppen', 'WHERE 1=1', '*', 'ORDER BY name ASC');
						foreach($kgs as $kg) {
							$data['values'][] = $kg['id'];
							$data['descs'][] = ko_html($kg['name'].' ('.getLL('ko_kleingruppen_wochentag_'.$kg['wochentag']).')');
						}
					}
					//Get groups
					if(ko_module_installed('groups')) {
						$data['values'][] = '';
						$data['descs'][] = '--- '.strtoupper(getLL('groups_groups')).' ---';
						$groups = ko_groups_get_recursive(ko_get_groups_zwhere(), TRUE);
						if(!is_array($all_groups)) ko_get_groups($all_groups);
						ko_get_access('groups');
						ko_get_grouproles($roles);
						$add_roles = ko_get_setting('tracking_add_roles') == 1;
						foreach($groups as $grp) {
							if($access['groups']['ALL'] < 1 && $access['groups'][$grp['id']] < 1) continue;
							$pre = '';
							$mother_line = ko_groups_get_motherline($grp['id'], $all_groups);
							$depth = sizeof($mother_line);
							for($i=0; $i<$depth; $i++) $pre .= '&nbsp;&nbsp;';
							$data['values'][] = 'g'.$grp['id'];
							$data['descs'][] = $pre.ko_html($grp['name']);
							//Add roles
							if($add_roles && $grp['roles'] != '') {
								foreach(explode(',', $grp['roles']) as $rid) {
									$data['values'][] = 'g'.$grp['id'].':r'.$rid;
									$data['descs'][] = $pre.ko_html($grp['name'].': '.$roles[$rid]['name']);
								}
							}
						}
					}
				break;

				case 'date_eventgroup':
					$data['values'][] = $data['descs'][] = '';
					ko_get_eventgruppen($grps, '', "AND `type` = '0'");
					foreach($grps as $grp) {
						$data["values"][] = $grp["id"];
						$data["descs"][] = $grp["name"];
					}
				break;

				case 'date_weekdays':
					$data['values'] = array(1,2,3,4,5,6,0);
					$monday = date_find_last_monday(date('Y-m-d'));
					for($i=0; $i<7; $i++) {
						$data['descs'][] = strftime('%A', strtotime(add2date($monday, 'tag', $i, TRUE)));
					}
				break;
			}
		break;  //ko_tracking

	}  //switch(table)

	return $data;
}//kota_get_form()





/**
  * Speichert die nderungen von einem Multiedit-Formular
	*/
function kota_submit_multiedit(&$error, $rights_level=0, $log_type="", $lastchange_col="", &$changes) {
	global $KOTA, $mysql_pass;
	global $access;

	list($table, $columns, $ids, $hash) = explode("@", $_POST["id"]);
	if(!$table || !$columns || $ids == "" || strlen($hash) != 32) $error = 58;
	$query = $log_message = array();

	//new entry
	$new_entry = FALSE;
	if($ids == 0) {
		$new_entry = TRUE;
		$new_id = $ids = db_insert_data($table, array("id" => "NULL"));
		$rights = '';  //Access rights to add new entries have to be checked in index.php before calling kota_submit_multiedit()
	} else {
		//Prepare to check for access rights to edit the selected items (check for new entries above has to be done in index.php)
		$rights = array();
		$module = $KOTA[$table]['_access']['module'];
		$chk_col = $KOTA[$table]['_access']['chk_col'];
		$entries = db_select_data($table, "WHERE `id` IN ('".implode("','", explode(',', $ids))."')");
		foreach($entries as $entry) {
			if(substr($chk_col, 0, 4) == 'ALL&') {
				$rights[$entry['id']] = ($access[$module]['ALL'] >= $rights_level || $access[$module][$entry[substr($chk_col, 4)]] >= $rights_level);
			} else if($chk_col != '') {
				$rights[$entry['id']] = ($access[$module][$entry[$chk_col]] >= $rights_level);
			} else {
				$rights[$entry['id']] = ($access[$module]['ALL'] >= $rights_level);
			}
		}
	}

	//Prepare query addition to store last change (if given)
	if($lastchange_col) $lastchange_query = ", `$lastchange_col` = NOW() ";

	//bergebene Werte
	$koi = $_POST["koi"][$table];

	//See, whether forAll has been checked
	if($koi["doForAll"]) $doForAll = TRUE;
	else $doForAll = FALSE;

	//add checkboxes. If they are deselected, then they are not in koi
	foreach(explode(",", $ids) as $id) {
		foreach(explode(",", $columns) as $kota_col_name) {
			$kota_col = $KOTA[$table][$kota_col_name];
			if($kota_col["form"]["type"] == "checkbox" && !isset($koi[$kota_col_name][$id])) {
				$koi[$kota_col_name][$id] = '0';
			}
		}//foreach(columns as kota_col_name)
	}//foreach(ids as id)

	//Alle POST-Werte durchgehen
	foreach($koi as $col => $values) {
		if($col == "forAll") continue;

		$col = format_userinput($col, "js");
		//Spalten mit _PLUS hinten gehren zu einem Textplus-Feld, werden deshalb schon bearbeitet (in kota_process_data())
		if(substr($col, -5) == "_PLUS") {
			//Add id for textplus fields, if they are not present. Can happen, if no values had been entered so far.
			if(!in_array($col, $test["columns"])) $test["columns"][] = substr($col, 0, -5);
			continue;
		}
		//only allow values set in KOTA
		if(!isset($KOTA[$table][$col])) continue;
		$test["columns"][] = $col;
		//If "dontsave" is set, then don't store the value here but add column to test, so check will work
		if($KOTA[$table][$col]["form"]["dontsave"]) continue;
		foreach($values as $id => $value) {
			if($doForAll) {
				$value = $koi[$col]["forAll"];
				if($koi[$col."_PLUS"]["forAll"]) $koi[$col."_PLUS"][$id] = $koi[$col."_PLUS"]["forAll"];
			}
			//ID und Berechtigung
			$id = format_userinput($id, "uint");
			if($rights != "" && !$rights[$id]) continue;

			//Wert formatieren
			$log = "";
			$process_data = array($col => $value);
			if($koi[$col."_PLUS"][$id]) $process_data[$col."_PLUS"] = $koi[$col."_PLUS"][$id];
			kota_process_data($table, $process_data, "post", $log, ($new_entry?$new_id:$id));
			$value = $process_data[$col];

			//Log-Message vorbereiten:
			if(!$log && substr($col, 0, 6) != "MODULE") {
				$old_v = db_select_data($table, "WHERE `id` = '$id'", '`'.$col.'`', '', '', TRUE);
				$old_value = $old_v[$col];
				if($old_value != $value) {
					$log_message[$id] .= "$col: ".$old_value." --> $value, ";
				}
			} else {
				$log_message[$id] .= $log;
			}

			//Query aufbauen, aber noch nicht ausfhren
			if(substr($col, 0, 9) == "MODULEgrp") $db_col = "groups";
			else if(substr($col, 0, 9) == "MODULEgdf") $db_col = "";  //Group datafields have already been stored in kota_process_data
			else $db_col = $col;
			if($db_col) {
				$query[] = "UPDATE $table SET `$db_col` = '$value' $lastchange_query WHERE `id` = '".($new_entry?$new_id:$id)."'";
				$changes[$table][($new_entry?$new_id:$id)][$db_col] = $value;
			}
			if($id != "") $test["ids"][] = $id;
		}
	}//foreach(koi as col => values)
	$test["ids"] = array_unique($test["ids"]);

	//IDs prfen, die nun nicht mehr vorkommen.
	//Es knnte sich um Checkboxen handeln, die deaktiviert wurden, denn dann wird der Wert von HTML gar nicht gesetzt
	$chk_ids = array_diff(explode(",", $ids), (array)$test["ids"]);
	foreach($chk_ids as $id) {
		foreach(explode(",", $columns) as $col) {
			if($KOTA[$table][$col]["form"]["dontsave"]) continue;
			if($KOTA[$table][$col]["form"]["type"] == "checkbox") {
				$query[] = "UPDATE $table SET `$col` = '0' $lastchange_query WHERE `id` = '$id'";
				$test["ids"][] = $id;
				$test["columns"][] = $col;
			}
			//Also add ids for Group datafields for people, that don't have this group. There will be no input field, so no koi entry.
			else if(substr($col, 0, 9) == "MODULEgdf" && !$koi[$col][$id]) {
				$test["ids"][] = $id;
				$test["columns"][] = $col;
				ko_get_person_by_id($id, $gdf_person);  //Get person's data to only process people who are assigned to the given group
				if(FALSE !== strpos($gdf_person["groups"], "g".substr($col, 9, 6))) {
					//Set checkbox as given by forAll or if forAll is not being used then set it to 0
					if($doForAll) $process_data = array($col => $koi[$col]["forAll"]);
					else $process_data = array($col => 0);
					kota_process_data($table, $process_data, "post", $log, $id);
				}
			}
		}
	}

	//Auf file-uploads testen
	foreach(explode(",", $columns) as $col) {
		if($KOTA[$table][$col]["form"]["type"] == "file") {
			if($new_entry) $ids = 0;
			foreach(explode(",", $ids) as $id) {
				//only save newly submitted files
				if($_FILES["koi"]["tmp_name"][$table][$col][$id]) {
					$data = array("table" => $table, "col" => $col, "id" => $id);
					kota_save_file($value, $data, $new_id);
					$query[] = "UPDATE $table SET `$col` = '".$value."' $lastchange_query WHERE `id` = '".($new_entry?$new_id:$id)."'";
				}
				//check for delete-checkbox for this file (only possible for edit)
				else if(!$new_entry && $koi[$col."_DELETE"][$id] == 1) {
					$col_value = db_select_data($table, "WHERE `id` = '$id'", '`'.$col.'`', "", "", TRUE);
					$data = array("table" => $table, "col" => $col, "id" => $id);
					kota_delete_file($col_value[$col], $data);
					$query[] = "UPDATE $table SET `$col` = '' $lastchange_query WHERE `id` = '$id'";
				}
				$test["ids"][] = $id;
			}//foreach(test[ids] as id)
			$test["columns"][] = $col;
		}
	}//foreach(columns as col)
	$test["ids"] = array_unique($test["ids"]);
	$test["columns"] = array_unique($test["columns"]);

	//bereinstimmung mit Hash-Wert checken
	sort($test["columns"]);
	sort($test["ids"]);
	if($new_entry) $test["ids"] = array(0);
	$test_string = $mysql_pass.$table.implode(":", $test["columns"]).implode(":", $test["ids"]);
	if(md5(md5($test_string)) != $hash) $error = 59;

	//print "new: '$test_string'<br />";
	//print "post: '".$_POST["id"]."'<br />";

	//DB aktualisieren
	if($error != 58 && $error != 59) {
		//Log-Meldung
		$log_type = $log_type ? $log_type : "multiedit@$table";
		foreach($log_message as $id => $log) {
			if(!$log) continue;
			$log = "$table ($id): $log";
			ko_log($log_type, $log);
			//Store version for ko_leute
			if($table == "ko_leute") ko_save_leute_changes($id);
		}//foreach(log_message as log)

		//Perform querys
		foreach($query as $q) mysql_query($q);
	}//if(!error)
	if($new_entry) return $new_id;
}//kota_submit_multiedit()




/**
  * Funktionen zur Nach-Behandlung (post) eines File-Uploads
	*/
function kota_save_file(&$value, $data, $new_id=0) {
	global $BASE_PATH;

	$dissallow_ext = array('php', 'php3', 'inc');

	$tmp = $_FILES["koi"]["tmp_name"][$data["table"]][$data["col"]][$data["id"]];
	if(!$tmp) return FALSE;
	$upload_name = $_FILES["koi"]["name"][$data["table"]][$data["col"]][$data["id"]];
	$ext_ = explode(".", $upload_name);
	$ext = $ext_[sizeof($ext_)-1];
	if(in_array($ext, $dissallow_ext)) return FALSE;

	$path = $BASE_PATH."my_images/";
	$filename = "kota_".$data["table"]."_".$data["col"]."_".($new_id?$new_id:$data["id"]).".".$ext;
	$dest = $path.$filename;

	$ret = move_uploaded_file($tmp, $dest);
	if($ret) {
		$value = "my_images/".$filename;
		chmod($dest, 0644);
	} else {
		$value = "";
	}

	//Unset _FILES values for this upload (so further processing, e.g. by kota_process_data() don't treat this again)
	unset($_FILES['koi']['name'][$data['table']][$data['col']][$data['id']]);
	unset($_FILES['koi']['type'][$data['table']][$data['col']][$data['id']]);
	unset($_FILES['koi']['tmp_name'][$data['table']][$data['col']][$data['id']]);
	unset($_FILES['koi']['error'][$data['table']][$data['col']][$data['id']]);
	unset($_FILES['koi']['size'][$data['table']][$data['col']][$data['id']]);
}//kota_save_file()


function kota_delete_file($value, $data) {
	global $BASE_PATH;

	$ext_ = explode(".", $value);
	$ext = $ext_[sizeof($ext_)-1];

	$path = $BASE_PATH."my_images/";
	$filename = "kota_".$data["table"]."_".$data["col"]."_".$data["id"].".".$ext;
	if(file_exists($path.$filename)) unlink($path.$filename);
}//kota_delete_file()




/**
  * Funktionen zur Nach-Behandlung (post) einzelner Formularfelder fr Multiedit
	*/
function ko_multiedit_familie(&$value, $data) {
	ko_get_person_by_id($data["id"], $p);
	if(!$p["famid"]) return FALSE;
	$fam_data[$data["col"]] = $value;
	ko_update_familie($p["famid"], $fam_data);
	return TRUE;
}//ko_multiedit_familie()



/**
 * Create new serie if new value has been entered
 */
function ko_multiedit_tapeserie(&$value, $data) {
	if((int)$value && format_userinput($value, "uint") == (int)$value) {
		//Do nothing, serie has been selected by id
	} else if(trim($value) != "") {
		$new_serie = format_userinput($value, "text");
		$value = db_insert_data("ko_tapes_series", array("name" => $new_serie, "printname" => $new_serie));
	} else {
		$value = "";
	}
}//ko_multiedit_tapeserie()



function ko_multiedit_tracking_group(&$value, $data) {
	if((int)$value && format_userinput($value, 'uint') == (int)$value) {
		//Do nothing, serie has been selected by id
	} else if(trim($value) != '') {
		$new_serie = format_userinput($value, 'text');
		$value = db_insert_data('ko_tracking_groups', array('name' => $new_serie));
	} else {
		$value = '';
	}
}//ko_multiedit_tracking_group()



function kota_mailing_check_unique_alias(&$value, $data) {
	global $error;

	if($value == '') return;
	//Enforce lowercase aliases
	$value = strtolower($value);

	//Check for disallowed aliases
	if(  1 == preg_match('/^sg([0-9]{4})([a-zA-Z.]*)$/', $value, $m)  //small group
		|| 1 == preg_match('/^gr([0-9.]*$)/', $value, $m)               //group
		|| $value == 'ml'                                               //my list
		|| substr($value, 0, strlen('confirm-')) == 'confirm-'          //confirm emails start with confirm-
		|| substr($value, 0, strlen('sms.')) == 'sms.'                  //Send sms instead of email
		|| substr($value, 0, strlen('filter.')) == 'filter.'            //Filter preset from people module
		) {
		$value = '';
		$error = 66;
		return;
	}

	//Get all current aliases for groups and small groups
	$aliases = array();
	$where_add = $data['table'] == 'ko_groups' ? " AND `id` != '".$data['id']."'" : '';
	$gr_aliases = db_select_data('ko_groups', "WHERE `mailing_alias` != ''".$where_add);
	foreach($gr_aliases as $g) $aliases[] = $g['mailing_alias'];
	$where_add = $data['table'] == 'ko_kleingruppen' ? " AND `id` != '".$data['id']."'" : '';
	$sg_aliases = db_select_data('ko_kleingruppen', "WHERE `mailing_alias` != ''".$where_add);
	foreach($sg_aliases as $g) $aliases[] = $g['mailing_alias'];

	//Unset alias if already present
	if(in_array($value, $aliases)) {
		$value = '';
		$error = 67;
	}
}//kota_mailing_check_unique_alias()


function kota_mailing_link_alias(&$value, $data) {
	global $MAILING_PARAMETER;

	if(!ko_module_installed('mailing', $_SESSION['ses_userid'])) return;
	if($MAILING_PARAMETER['domain'] == '') return;

	$value = '<a href="mailto:'.$value.'@'.$MAILING_PARAMETER['domain'].'">'.$value.'</a>';
}//kota_mailing_link_alias()



function kota_pic_tooltip(&$value, $data) {
	$value = ko_pic_get_tooltip($value, 25, 200, 'm', 'l');
}//kota_pic_tooltip()



function kota_sort_comma_list(&$value, $data) {
	if(!$value) return FALSE;
	$a = explode(',', $value);
	asort($a);
	$value = implode(',', $a);
}//kota_sort_comma_list()




/**
  * Functions to format some standard values displayed in lists
	*/

function kota_listview_date(&$value, $data) {
	global $DATETIME;

	$d = $data["dataset"];
	if($d["enddatum"] != $d["startdatum"]) {
		$value = strftime($DATETIME["ddmy"], strtotime($d["startdatum"])) . "-" . strftime($DATETIME["ddmy"], strtotime($d["enddatum"]));
	} else {
		$value = strftime($DATETIME["ddmy"], strtotime($d["startdatum"]));
	}
}//kota_listview_date()


function kota_listview_time(&$value, $data) {
	$d = $data["dataset"];

	//Add seconds which might have been cut of by kota_process_data already
	if(strlen($d["startzeit"]) == 5) $d["startzeit"] .= ":00";
	if(strlen($d["endzeit"]) == 5) $d["endzeit"] .= ":00";

	if($d["startzeit"] == "00:00:00") {
		$value = getLL("time_all_day");
	} else if($d["endzeit"] != "" && $d["endzeit"] != "00:00:00") {
		$value = substr($d["startzeit"], 0, -3) . " - " . substr($d["endzeit"], 0, -3);
	} else {
		$value = substr($d["startzeit"], 0, -3);
	}
}//kota_listview_time()


function kota_listview_boolyesno(&$value, $data) {
	$value = $value?getLL("yes"):getLL("no");
}//kota_listview_boolyesno()


function kota_listview_boolx(&$value, $data) {
	$value = $value?"x":"";
}//kota_listview_boolx()


function kota_listview_people(&$value, $data) {
	$id = $data["dataset"][$data["col"]];
	$ids = explode(",", $id);
	$a_value = array();
	$persons = db_select_data('ko_leute', "WHERE `id` IN ('".implode("','", $ids)."')");
	foreach($persons as $p) {
		//Mark deleted persons but still show them
		$pre = $p['deleted'] == 1 ? '<span style="text-decoration: line-through;" title="'.getLL('leute_labels_deleted').'">' : '';
		$post = $p['deleted'] == 1 ? '</span>' : '';
		if(trim($p['vorname']) == '' && trim($p['nachname']) == '') {
			$a_value[] = $pre.$p["firm"].($p['department'] ? ' ('.$p['department'].')' : '').$post;
		} else {
			$a_value[] = $pre.$p["vorname"]." ".$p["nachname"].$post;
		}
	}
	$value = implode(", ", $a_value);
}//kota_listview_people()

function kota_listview_login(&$value, $data) {
	$login = db_select_data("ko_admin", "WHERE `id` ='$value'", "login", "", "", TRUE);
	$value = $login["login"];
}//kota_listview_login()


function kota_listview_longtext25(&$value, $data) {
	$value = '<span title="'.ko_html($value).'">'.substr($value, 0, 25).(strlen($value)>25?"..":"").'</span>';
}//kota_listview_longtext25()


function kota_listview_ll(&$value, $data) {
	$prefix = "kota_".$data["table"]."_".$data["col"]."_";
	$value = $value != "" ? getLL($prefix.$value) : "";
}//kota_listview_ll()



/**
 * Show number of reservations for a single event in list view. Tooltip shows single reservation's details
 */
function kota_listview_event_reservations(&$value, $data) {
	$ids = explode(',', $value);
	foreach($ids as $k => $v) {
		if(!$v) unset($ids[$k]);
	}
	if(sizeof($ids) > 0) {
		//Get reservation infos
		$res = db_select_data('ko_reservation AS r LEFT JOIN ko_resitem AS i ON r.item_id = i.id', "WHERE r.id IN ('".implode("','", $ids)."')", 'i.name AS resitem_name, r.startzeit, r.endzeit, r.zweck', '', '', FALSE, TRUE);
		$txt = '';
		foreach($res as $r) {
			//Add resitem
			$txt .= '<b>- '.$r['resitem_name'].'</b><br />';
			//Format time
			if($r['startzeit'] == '00:00:00' && $r['endzeit'] == '00:00:00') {
				$time = getLL('time_all_day');
			} else {
				$time = substr($r['startzeit'], 0, -3);
				if($r['endzeit'] != '00:00:00') $time .= ' - '.substr($r['endzeit'], 0, -3);
			}
			$txt .= $time.'<br />';
			//Add purpose of reservation
			if($r['zweck']) $txt .= strtr(trim($r['zweck']), array("\n" => "<br />", "\r" => "", "\t" => "", "'" => "\'")).'<br />';
			$txt .= '<br />';
		}
		if($txt != '') {
			//Add title
			$txt = getLL('daten_list_reservations_title').':<br /><br />'.htmlspecialchars($txt);
			$value = '<a href="#" onclick="return false;" onmouseover="tooltip.show(\''.$txt.'\', \'auto\', \'b\', \'l\');" onmouseout="tooltip.hide();">&nbsp;'.sizeof($ids).'&nbsp;</a>';
		} else {
			$value = '';
		}
	} else {
		$value = '';
	}
}//kota_listview_event_reservations()




/**
  * Assigns values to a certain KOTA entry
	* Multiple assignement possible
	*/
function kota_assign_values($table, $cols, $pre_process=TRUE) {
	global $KOTA;

	foreach($cols as $col => $value) {
		if(!is_array($KOTA[$table][$col]["form"])) continue;
		$process_data = array($col => $value);
		if($pre_process) kota_process_data($table, $process_data, "pre");
		$KOTA[$table][$col]["form"]["value"] = $process_data[$col];
		//doubleselect
		if($KOTA[$table][$col]["form"]["type"] == "doubleselect") {
			foreach(explode(",", $process_data[$col]) as $v) {
				$KOTA[$table][$col]["form"]["avalues"][] = $v;
				$valuesi = array_flip($KOTA[$table][$col]["form"]["values"]);
				$KOTA[$table][$col]["form"]["adescs"][] = $KOTA[$table][$col]["form"]["descs"][$valuesi[$v]];
			}
			$KOTA[$table][$col]["form"]["avalue"] = $process_data[$col];
		}
	}
}//kota_assign_values()



/**
  * processes a data array according to the rules in KOTA
	* modes can be pre, post or list
	* modes can also be a comma list of the above values, then the first available is applied, but only one
	*/
function kota_process_data($table, &$data, $modes, &$log, $id=0) {
	global $KOTA;

	if(!is_array($modes)) $modes = explode(",", $modes);

	foreach($data as $col => $value) {
		if(!isset($KOTA[$table][$col])) continue;

		$kota_data = array("table" => $table, "col" => $col, "id" => $id, "dataset" => &$data);

		//Bei Textplus-feldern auf Wert im Text-feld berprfen und diesen verwenden falls != ""
		if($KOTA[$table][$col]["form"]["type"] == "textplus") {
			$plus_value = $data[$col."_PLUS"];
			if(is_array($plus_value)) $plus_value = array_shift($plus_value);
			if($plus_value != "") $value = $plus_value;
			unset($data[$col."_PLUS"]);
		}

		//get first array element, if value is array
		if(is_array($value)) $value = array_shift($value);

		//Modules
		if(substr($col, 0, 6) == "MODULE") {
			if(substr($col, 6, 3) == "grp") {
				//Get id of edited group
				$gid = substr($col, 9, 6);
				//Get new save string
				ko_groups_get_savestring($value, array("id" => $id, "col" => $col), $log, NULL, TRUE, (in_array("post", $modes)));
				//If group has been deselected then delete all group datafields for this group
				if($gid && FALSE === strpos($value, 'g'.$gid)) db_delete_data('ko_groups_datafields_data', "WHERE `group_id` = '$gid' AND `person_id` = '".$id."'");
			}//grp
			if(substr($col, 6, 3) == "gdf") {
				$gid = substr($col, 9, 6);
				$fid = substr($col, 15, 6);
				$cdf = db_select_data("ko_groups_datafields_data", "WHERE `datafield_id` = '$fid' AND `person_id` = '$id' AND `group_id` = '$gid'", "*", "", "", TRUE);
				if(!$cdf) {  //Add new entry
					db_insert_data("ko_groups_datafields_data", array("group_id" => $gid, "person_id" => $id, "datafield_id" => $fid, "value" => $value));
					$log = getLL("leute_log_datafields")." (g$gid:$fid) for $id: $value";
				} else {  //Update current entry
					if($cdf["value"] != $value) {
						db_update_data("ko_groups_datafields_data", "WHERE `datafield_id` = '$fid' AND `person_id` = '$id' AND `group_id` = '$gid'", array("value" => $value));
						$log = getLL("leute_log_datafields")." (g$gid:$fid) for $id: $value";
					}
				}
			}//gdf
		}//MODULE

		$fu_modes = array("uint", "int", "int@", "intlist", "alphanumlist", "float", "alphanum", "alphanum+", "alphanum++", "email", "dir", "js", "alpha", "alpha+", "alpha++", "date");
		$done = FALSE;
		foreach($modes as $mode) {
			if($done) continue;

			//process data
			if($KOTA[$table][$col][$mode]) {
				$done = TRUE;
				//Separate Funktion aufrufen
				if(substr($KOTA[$table][$col][$mode], 0, 4) == "FCN:") {
					$fcn = substr($KOTA[$table][$col][$mode], 4);
					if(function_exists($fcn)) {
						eval("$fcn(\$value, \$kota_data, \$log);");
					}
				} else {  //Apply function
					if($KOTA[$table][$col][$mode] == "ko_html") {  //Just apply ko_html (usually used for pre)
						$value = ko_html($value);
					} else if(in_array($KOTA[$table][$col][$mode], $fu_modes)) {  //simple format_userinput()
						$value = format_userinput($value, $KOTA[$table][$col][$mode]);
					} else if($KOTA[$table][$col][$mode] == "none") {
						//Do nothing
					} else {  //Other, user-defined function, where @VALUE@ is substituted
						eval("\$value=".str_replace("@VALUE@", addslashes($value), $KOTA[$table][$col][$mode]).";");
					}
				}
			} else {
				$value = format_userinput($value, "text");
			}
		}//foreach(explode(",", modes))
		$data[$col] = $value;

		//Auf file-uploads testen
		if($KOTA[$table][$col]["form"]["type"] == "file"
			|| (substr($col, -7) == '_DELETE' && $KOTA[$table][substr($col, 0, -7)]['form']['type'] == 'file')
		) {
			//only save newly submitted files
			if($_FILES["koi"]["tmp_name"][$table][$col][$id]) {
				$fdata = array("table" => $table, "col" => $col, "id" => $id);
				kota_save_file($value, $fdata, $id);
				db_update_data($table, "WHERE `id` = '$id'", array($col => $value));
			}
			//check for delete-checkbox for this file (only possible for edit)
			else if(is_array($value)) {
				$id = array_pop(array_keys($value));
				if($value[$id] == 1) {
					$col = substr($col, 0, -7);
					$col_value = db_select_data($table, "WHERE `id` = '$id'", '`'.$col.'`', "", "", TRUE);
					$fdata = array("table" => $table, "col" => $col, "id" => $id);
					kota_delete_file($col_value[$col], $fdata);
					db_update_data($table, "WHERE `id` = '$id'", array($col => ''));
					unset($data[$col.'_DELETE']);
				}
			}
		}

	}//foreach(data as col => value)

	//Check for checkboxes (don't show up in $data if not set (anymore))
  foreach($KOTA[$table] as $col => $v) {
    if(isset($data[$col])) continue;
    if($v['form']['type'] == 'checkbox') {
      $data[$col] = 0;
    }
  }


}//kota_process_data()



/**
  * returns an array of formatted values with the array-key being the description of the KOTA field
	*/
function kota_get_list($data, $table) {
	global $KOTA;

	kota_process_data($table, $data, "list,pre");

	$list = array();
	foreach($data as $col => $value) {
		$ll_value = getLL("kota_".$table."_".$col);
		if(!$ll_value) continue;

		$list[$ll_value] = $value;
	}
	return $list;
}//kota_get_list()




/**
  * Convert the values and descs used for a dynselect to values/descs used for a select with optgroups (used for multiediting)
	* See kota_ko_event_eventgruppen_id_dynselect or kota_ko_reservation_item_id_dynselect for examples
	*/
function kota_convert_dynselect_select($values, $descs) {
	$new_values = $new_descs = array();
	//convert all top level elements with their children elements
	foreach($values as $ivid => $value) {
		if(substr($ivid, 0, 1) != "i") continue;
		$vid = substr($ivid, 1);
		$new_values[$ivid] = $descs[$ivid];
		foreach($value as $gid) {
			$new_descs[$ivid][$gid] = $descs[$gid];
		}
	}
	//Add top level elements without children
	foreach($values as $gid) {
		if(substr($gid, 0, 1) == "i") continue;
		$new_values[$gid] = $gid;
		$new_descs[$gid] = $descs[$gid];
	}
	return array($new_values, $new_descs);
}//kota_convert_dynselect_select()

?>
