<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2011 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

//Session-ID verlangen
if(!isset($_GET['sesid'])) exit;
 
//Session laden
if(FALSE === session_id($_GET['sesid'])) exit;
if(FALSE === session_start()) exit;

//Send headers to ensure latin1 charset
header('Content-Type: text/html; charset=ISO-8859-1');
 
error_reporting(0);
$ko_menu_akt = 'tracking';
$ko_path = '../../';
require($ko_path.'inc/ko.inc');
$ko_path = '../';

//Get access rights
ko_get_access('tracking');
if($access['tracking']['MAX'] < 1) exit;

ko_include_kota(array('ko_tracking'));

// Plugins einlesen:
$hooks = hook_include_main('tracking');
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);
 
//Smarty-Templates-Engine laden
require($BASE_PATH.'inc/smarty.inc');
 
require($BASE_PATH.'tracking/inc/tracking.inc');

//HOOK: Submenus einlesen
$hooks = hook_include_sm();
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);

hook_show_case_pre($_SESSION['show']);

 
if(isset($_GET) && isset($_GET['action'])) {
 	$action = format_userinput($_GET['action'], 'alphanum');
 	switch($action) {

		case 'setstart':
			//Start fr Listenansicht setzen
			if(FALSE === ($_SESSION['show_start'] = format_userinput($_GET['set_start'], 'uint'))) {
    	  $_SESSION['show_start'] = 1;
	    }

			print 'main_content@@@';
			print ko_list_trackings(FALSE);
		break;


		case 'setsort':
			$_SESSION['sort_trackings'] = format_userinput($_GET['sort'], 'alphanum+', TRUE, 30);
			$_SESSION['sort_trackings_order'] = format_userinput($_GET['sort_order'], 'alpha', TRUE, 4);

			print 'main_content@@@';
			print ko_list_trackings(FALSE);
		break;
 

 		case 'settrackingsimple':
 		case 'settrackingvalue':
 			if($access['tracking']['MAX'] < 2) continue;

			$data = array();
			$data['tid'] = format_userinput($_GET['tid'], 'uint');
			if($access['tracking']['ALL'] < 2 && $access['tracking'][$data['tid']] < 2) continue;
			$data['lid'] = format_userinput($_GET['lid'], 'uint');
			$data['date'] = format_userinput($_GET['date'], 'date');
			if($action == 'settrackingsimple') {
				$data['value'] = format_userinput($_GET['value'], 'uint') == 1 ? 0 : 1;
			} else {
				$data['value'] = $_GET['value'];
			}

			$entry = db_select_data('ko_tracking_entries', "WHERE `tid` = '".$data['tid']."' AND `lid` = '".$data['lid']."' AND `date` = '".$data['date']."'", '*', '', '', TRUE);
			if(isset($entry['id']) && $entry['id'] > 0) {
				db_update_data('ko_tracking_entries', "WHERE `id` = '".$entry['id']."'", $data);
			} else {
				db_insert_data('ko_tracking_entries', $data);
			}
			ko_log_diff('enter_tracking', $data);

			print 'tstate_'.$data['lid'].'_'.$data['date'].'@@@';
			print '<img src="'.$ko_path.'images/button_check.png" width="16" height="16" alt="OK" />';
		break;


 		case 'settrackingtype':
 			if($access['tracking']['MAX'] < 2) continue;

			$data = array();
			$data['tid'] = format_userinput($_GET['tid'], 'uint');
			if($access['tracking']['ALL'] < 2 && $access['tracking'][$data['tid']] < 2) continue;
			$data['lid'] = format_userinput($_GET['lid'], 'uint');
			$data['date'] = format_userinput($_GET['date'], 'date');
			$data['value'] = format_userinput($_GET['value'], 'float');
			$data['type'] = utf8_decode($_GET['type']);

			$entry = db_select_data('ko_tracking_entries', "WHERE `tid` = '".$data['tid']."' AND `lid` = '".$data['lid']."' AND `date` = '".$data['date']."' AND `type` = '".$data['type']."'", '*', '', '', TRUE);
			if(isset($entry['id']) && $entry['id'] > 0) {
				(float)$data['value'] += (float)$entry['value'];
				db_update_data('ko_tracking_entries', "WHERE `id` = '".$entry['id']."'", $data);
			} else {
				db_insert_data('ko_tracking_entries', $data);
			}
			ko_log_diff('enter_tracking', $data);

			//Redraw content for tracking list
			print 'main_content@@@';
			ko_tracking_enter_form(FALSE);
		break;


		case 'deltrackingtype':
 			if($access['tracking']['MAX'] < 2) continue;

			$data = array();
			$data['tid'] = format_userinput($_GET['tid'], 'uint');
			if($access['tracking']['ALL'] < 2 && $access['tracking'][$data['tid']] < 2) continue;
			$data['lid'] = format_userinput($_GET['lid'], 'uint');
			$data['date'] = format_userinput($_GET['date'], 'date');
			$data['type'] = utf8_decode($_GET['type']);

			db_delete_data('ko_tracking_entries', "WHERE `tid` = '".$data['tid']."' AND `lid` = '".$data['lid']."' AND `date` = '".$data['date']."' AND `type` = '".$data['type']."'");
			ko_log_diff('del_entered_tracking', $data);

			//Redraw content for tracking list
			print 'main_content@@@';
			ko_tracking_enter_form(FALSE);
		break;



		case 'itemlist':
			//ID and state of the clicked field
			$id = format_userinput($_GET['id'], 'js');
			$state = $_GET['state'] == 'true' ? 'checked' : '';

			//Single event group selected
			if($state == 'checked') {  //Select it
				if(!in_array($id, $_SESSION['show_tracking_groups'])) $_SESSION['show_tracking_groups'][] = $id;
			} else {  //deselect it
				if(in_array($id, $_SESSION['show_tracking_groups'])) $_SESSION['show_tracking_groups'] = array_diff($_SESSION['show_tracking_groups'], array($id));
			}
			array_unique($_SESSION['show_tracking_groups']);
			foreach($_SESSION['show_tracking_groups'] as $k => $v) {
				if($v == '') unset($_SESSION['show_tracking_groups'][$k]);
			}

			//Save userpref
			sort($_SESSION['show_tracking_groups']);
			ko_save_userpref($_SESSION['ses_userid'], 'show_tracking_groups', implode(',', $_SESSION['show_tracking_groups']));

			//Redraw content for tracking list
			print 'main_content@@@';
			ko_list_trackings(FALSE);
		break;


		case 'itemlistsave':
			//Find position of submenu for redraw
			if(in_array('itemlist_trackinggroups', explode(',', $_SESSION['submenu_left']))) $pos = 'left';
			else $pos = 'right';

			//save new value
			if($_GET['name'] == '') continue;
			$new_value = implode(',', $_SESSION['show_tracking_groups']);
			$user_id = $access['tracking']['MAX'] > 3 && $_GET['global'] == 'true' ? '-1' : $_SESSION['ses_userid'];
			ko_save_userpref($user_id, format_userinput($_GET['name'], 'js', FALSE, 0, array('allquotes')), $new_value, 'tracking_itemset');

			print submenu_tracking('itemlist_trackinggroups', $pos, 'open', 2);
		break;


		case 'itemlistopen':
			//Find position of submenu for redraw
			if(in_array('itemlist_trackinggroups', explode(',', $_SESSION['submenu_left']))) $pos = 'left';
			else $pos = 'right';

			//save new value
			$name = format_userinput($_GET['name'], 'js', FALSE, 0, array(), '@');
			if($name == '') continue;

			if(substr($name, 0, 3) == '@G@') $value = ko_get_userpref('-1', substr($name, 3), 'tracking_itemset');
			else $value = ko_get_userpref($_SESSION['ses_userid'], $name, 'tracking_itemset');
			$_SESSION['show_tracking_groups'] = explode(',', $value[0]['value']);
			ko_save_userpref($_SESSION['ses_userid'], 'show_tracking_groups', $value[0]['value']);

			print submenu_tracking('itemlist_trackinggroups', $pos, 'open', 2);
			print '@@@main_content@@@';
			ko_list_trackings(FALSE);
		break;


		case 'itemlistdelete':
			//Find position of submenu for redraw
			if(in_array('itemlist_trackinggroups', explode(',', $_SESSION['submenu_left']))) $pos = 'left';
			else $pos = 'right';

			//Get name
			$name = format_userinput($_GET['name'], 'js', FALSE, 0, array(), '@');
			if($name == '') continue;

			if(substr($name, 0, 3) == '@G@') {
				if($access['tracking']['MAX'] > 3) ko_delete_userpref('-1', substr($name, 3), 'tracking_itemset');
			} else ko_delete_userpref($_SESSION['ses_userid'], $name, 'tracking_itemset');

			print submenu_tracking('itemlist_trackinggroups', $pos, 'open', 2);
		break;

	}//switch(action);
}//if(GET[action])
?>
